/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM /usr/src/packages/BUILD/thunderbird/mail/components/activity/nsIActivity.idl
 */

#ifndef __gen_nsIActivity_h__
#define __gen_nsIActivity_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsISupportsPrimitives_h__
#include "nsISupportsPrimitives.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIActivityListener; /* forward declaration */

class nsIActivity; /* forward declaration */

class nsIActivityProcess; /* forward declaration */

class nsIActivityEvent; /* forward declaration */

class nsIActivityWarning; /* forward declaration */

class nsIVariant; /* forward declaration */

class nsISupportsPRTime; /* forward declaration */


/* starting interface:    nsIActivityRecoveryHandler */
#define NS_IACTIVITYRECOVERYHANDLER_IID_STR "30e0a76f-880a-4093-8f3c-af2239977a3d"

#define NS_IACTIVITYRECOVERYHANDLER_IID \
  {0x30e0a76f, 0x880a, 0x4093, \
    { 0x8f, 0x3c, 0xaf, 0x22, 0x39, 0x97, 0x7a, 0x3d }}

/**
 * See https://wiki.mozilla.org/Thunderbird:Activity_Manager/Developer for UML
 * diagram and sample codes.
 */
/**
 * Background:
 * Activity handlers define the behavioral capabilities of the activities. They
 * are used by the Activity Manager to change the execution flow of the activity
 * based on the user interaction. They are not mandatory, but when set, causes
 * behavioral changes on the binding representing the activity, such as showing
 * a cancel button, etc. The following handlers are currently supported;
 */
/**
 * The handler to invoke when the recover button is pressed. Used by a Warning
 * to recover from the situation causing the warning. For instance, recovery
 * action for a "Over Quota Limit" warning, would be to cleanup some disk space,
 * and this operation can be implemented and set by the activity developer in
 * form of nsIActivityRecoveryHandler component.
 */
class NS_NO_VTABLE NS_SCRIPTABLE nsIActivityRecoveryHandler : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IACTIVITYRECOVERYHANDLER_IID)

  /* nsresult recover (in nsIActivityWarning aActivity); */
  NS_SCRIPTABLE NS_IMETHOD Recover(nsIActivityWarning *aActivity, nsresult *_retval NS_OUTPARAM) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIActivityRecoveryHandler, NS_IACTIVITYRECOVERYHANDLER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIACTIVITYRECOVERYHANDLER \
  NS_SCRIPTABLE NS_IMETHOD Recover(nsIActivityWarning *aActivity, nsresult *_retval NS_OUTPARAM); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIACTIVITYRECOVERYHANDLER(_to) \
  NS_SCRIPTABLE NS_IMETHOD Recover(nsIActivityWarning *aActivity, nsresult *_retval NS_OUTPARAM) { return _to Recover(aActivity, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIACTIVITYRECOVERYHANDLER(_to) \
  NS_SCRIPTABLE NS_IMETHOD Recover(nsIActivityWarning *aActivity, nsresult *_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->Recover(aActivity, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsActivityRecoveryHandler : public nsIActivityRecoveryHandler
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIACTIVITYRECOVERYHANDLER

  nsActivityRecoveryHandler();

private:
  ~nsActivityRecoveryHandler();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsActivityRecoveryHandler, nsIActivityRecoveryHandler)

nsActivityRecoveryHandler::nsActivityRecoveryHandler()
{
  /* member initializers and constructor code */
}

nsActivityRecoveryHandler::~nsActivityRecoveryHandler()
{
  /* destructor code */
}

/* nsresult recover (in nsIActivityWarning aActivity); */
NS_IMETHODIMP nsActivityRecoveryHandler::Recover(nsIActivityWarning *aActivity, nsresult *_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIActivityCancelHandler */
#define NS_IACTIVITYCANCELHANDLER_IID_STR "35ee2461-70db-4b3a-90d0-7a68c856e911"

#define NS_IACTIVITYCANCELHANDLER_IID \
  {0x35ee2461, 0x70db, 0x4b3a, \
    { 0x90, 0xd0, 0x7a, 0x68, 0xc8, 0x56, 0xe9, 0x11 }}

/**
 * The handler to invoke when the cancel button is pressed. Used by a Process to
 * cancel the operation.
 */
class NS_NO_VTABLE NS_SCRIPTABLE nsIActivityCancelHandler : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IACTIVITYCANCELHANDLER_IID)

  /* nsresult cancel (in nsIActivityProcess aActivity); */
  NS_SCRIPTABLE NS_IMETHOD Cancel(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIActivityCancelHandler, NS_IACTIVITYCANCELHANDLER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIACTIVITYCANCELHANDLER \
  NS_SCRIPTABLE NS_IMETHOD Cancel(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIACTIVITYCANCELHANDLER(_to) \
  NS_SCRIPTABLE NS_IMETHOD Cancel(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM) { return _to Cancel(aActivity, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIACTIVITYCANCELHANDLER(_to) \
  NS_SCRIPTABLE NS_IMETHOD Cancel(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->Cancel(aActivity, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsActivityCancelHandler : public nsIActivityCancelHandler
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIACTIVITYCANCELHANDLER

  nsActivityCancelHandler();

private:
  ~nsActivityCancelHandler();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsActivityCancelHandler, nsIActivityCancelHandler)

nsActivityCancelHandler::nsActivityCancelHandler()
{
  /* member initializers and constructor code */
}

nsActivityCancelHandler::~nsActivityCancelHandler()
{
  /* destructor code */
}

/* nsresult cancel (in nsIActivityProcess aActivity); */
NS_IMETHODIMP nsActivityCancelHandler::Cancel(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIActivityPauseHandler */
#define NS_IACTIVITYPAUSEHANDLER_IID_STR "9eee22bf-5378-460e-83a7-781cdcc9050b"

#define NS_IACTIVITYPAUSEHANDLER_IID \
  {0x9eee22bf, 0x5378, 0x460e, \
    { 0x83, 0xa7, 0x78, 0x1c, 0xdc, 0xc9, 0x05, 0x0b }}

/**
 * The handler to invoke when the pause button is pressed. Used by a Process to
 * pause/resume the operation.
 */
class NS_NO_VTABLE NS_SCRIPTABLE nsIActivityPauseHandler : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IACTIVITYPAUSEHANDLER_IID)

  /* nsresult pause (in nsIActivityProcess aActivity); */
  NS_SCRIPTABLE NS_IMETHOD Pause(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM) = 0;

  /* nsresult resume (in nsIActivityProcess aActivity); */
  NS_SCRIPTABLE NS_IMETHOD Resume(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIActivityPauseHandler, NS_IACTIVITYPAUSEHANDLER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIACTIVITYPAUSEHANDLER \
  NS_SCRIPTABLE NS_IMETHOD Pause(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD Resume(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIACTIVITYPAUSEHANDLER(_to) \
  NS_SCRIPTABLE NS_IMETHOD Pause(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM) { return _to Pause(aActivity, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD Resume(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM) { return _to Resume(aActivity, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIACTIVITYPAUSEHANDLER(_to) \
  NS_SCRIPTABLE NS_IMETHOD Pause(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->Pause(aActivity, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD Resume(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->Resume(aActivity, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsActivityPauseHandler : public nsIActivityPauseHandler
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIACTIVITYPAUSEHANDLER

  nsActivityPauseHandler();

private:
  ~nsActivityPauseHandler();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsActivityPauseHandler, nsIActivityPauseHandler)

nsActivityPauseHandler::nsActivityPauseHandler()
{
  /* member initializers and constructor code */
}

nsActivityPauseHandler::~nsActivityPauseHandler()
{
  /* destructor code */
}

/* nsresult pause (in nsIActivityProcess aActivity); */
NS_IMETHODIMP nsActivityPauseHandler::Pause(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsresult resume (in nsIActivityProcess aActivity); */
NS_IMETHODIMP nsActivityPauseHandler::Resume(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIActivityRetryHandler */
#define NS_IACTIVITYRETRYHANDLER_IID_STR "8ec42517-951f-4bc0-aba5-fde7258b1705"

#define NS_IACTIVITYRETRYHANDLER_IID \
  {0x8ec42517, 0x951f, 0x4bc0, \
    { 0xab, 0xa5, 0xfd, 0xe7, 0x25, 0x8b, 0x17, 0x05 }}

/**
 * The handler to invoke when the retry button is pressed. Used by a Process to
 * retry the operation in case of failure.
 */
class NS_NO_VTABLE NS_SCRIPTABLE nsIActivityRetryHandler : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IACTIVITYRETRYHANDLER_IID)

  /* nsresult retry (in nsIActivityProcess aActivity); */
  NS_SCRIPTABLE NS_IMETHOD Retry(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIActivityRetryHandler, NS_IACTIVITYRETRYHANDLER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIACTIVITYRETRYHANDLER \
  NS_SCRIPTABLE NS_IMETHOD Retry(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIACTIVITYRETRYHANDLER(_to) \
  NS_SCRIPTABLE NS_IMETHOD Retry(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM) { return _to Retry(aActivity, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIACTIVITYRETRYHANDLER(_to) \
  NS_SCRIPTABLE NS_IMETHOD Retry(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->Retry(aActivity, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsActivityRetryHandler : public nsIActivityRetryHandler
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIACTIVITYRETRYHANDLER

  nsActivityRetryHandler();

private:
  ~nsActivityRetryHandler();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsActivityRetryHandler, nsIActivityRetryHandler)

nsActivityRetryHandler::nsActivityRetryHandler()
{
  /* member initializers and constructor code */
}

nsActivityRetryHandler::~nsActivityRetryHandler()
{
  /* destructor code */
}

/* nsresult retry (in nsIActivityProcess aActivity); */
NS_IMETHODIMP nsActivityRetryHandler::Retry(nsIActivityProcess *aActivity, nsresult *_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIActivityUndoHandler */
#define NS_IACTIVITYUNDOHANDLER_IID_STR "b8632ac7-9d8b-4341-a349-ef000e8c89ac"

#define NS_IACTIVITYUNDOHANDLER_IID \
  {0xb8632ac7, 0x9d8b, 0x4341, \
    { 0xa3, 0x49, 0xef, 0x00, 0x0e, 0x8c, 0x89, 0xac }}

/**
 * The handler to invoke when the undo button is pressed. Used by a Event to
 * undo the operation generated the event.
 */
class NS_NO_VTABLE NS_SCRIPTABLE nsIActivityUndoHandler : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IACTIVITYUNDOHANDLER_IID)

  /* nsresult undo (in nsIActivityEvent aActivity); */
  NS_SCRIPTABLE NS_IMETHOD Undo(nsIActivityEvent *aActivity, nsresult *_retval NS_OUTPARAM) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIActivityUndoHandler, NS_IACTIVITYUNDOHANDLER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIACTIVITYUNDOHANDLER \
  NS_SCRIPTABLE NS_IMETHOD Undo(nsIActivityEvent *aActivity, nsresult *_retval NS_OUTPARAM); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIACTIVITYUNDOHANDLER(_to) \
  NS_SCRIPTABLE NS_IMETHOD Undo(nsIActivityEvent *aActivity, nsresult *_retval NS_OUTPARAM) { return _to Undo(aActivity, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIACTIVITYUNDOHANDLER(_to) \
  NS_SCRIPTABLE NS_IMETHOD Undo(nsIActivityEvent *aActivity, nsresult *_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->Undo(aActivity, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsActivityUndoHandler : public nsIActivityUndoHandler
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIACTIVITYUNDOHANDLER

  nsActivityUndoHandler();

private:
  ~nsActivityUndoHandler();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsActivityUndoHandler, nsIActivityUndoHandler)

nsActivityUndoHandler::nsActivityUndoHandler()
{
  /* member initializers and constructor code */
}

nsActivityUndoHandler::~nsActivityUndoHandler()
{
  /* destructor code */
}

/* nsresult undo (in nsIActivityEvent aActivity); */
NS_IMETHODIMP nsActivityUndoHandler::Undo(nsIActivityEvent *aActivity, nsresult *_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIActivity */
#define NS_IACTIVITY_IID_STR "6cd33e65-b2d8-4634-9b6d-b80bf1273e99"

#define NS_IACTIVITY_IID \
  {0x6cd33e65, 0xb2d8, 0x4634, \
    { 0x9b, 0x6d, 0xb8, 0x0b, 0xf1, 0x27, 0x3e, 0x99 }}

class NS_NO_VTABLE NS_SCRIPTABLE nsIActivity : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IACTIVITY_IID)

  /**
 * Base interface of all activity interfaces. It is abstract in a sense that
 * there is no component in the activity management system that solely
 * implements this interface.
 */
/**
   * Shows the activity as a standalone item.
   */
  enum { GROUPING_STYLE_STANDALONE = 1 };

  /**
   * Groups activity by its context.
   */
  enum { GROUPING_STYLE_BYCONTEXT = 2 };

  /**
   * Internal ID given by the activity manager when
   * added into the activity list.  Not readonly so that
   * the activity manager can write to them, but not to be written to
   * by anyone else.
   */
  /* attribute unsigned long id; */
  NS_SCRIPTABLE NS_IMETHOD GetId(PRUint32 *aId) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetId(PRUint32 aId) = 0;

  /**
   * A brief description of the activity, to be shown by the
   * associated binding (XBL) in the Activity Manager window.
   */
  /* readonly attribute AString displayText; */
  NS_SCRIPTABLE NS_IMETHOD GetDisplayText(nsAString & aDisplayText) = 0;

  /**
   * Changes the default icon associated with the activity. Core activity
   * icons are declared in |mail/themes/<themename>/mail/activity/activity.css|
   * files.
   *
   * Extension developers can add and assign their own icons by setting
   * this attribute.
   */
  /* attribute AString iconClass; */
  NS_SCRIPTABLE NS_IMETHOD GetIconClass(nsAString & aIconClass) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetIconClass(const nsAString & aIconClass) = 0;

  /**
   * Textual id of the XBL binding that will be used to represent the
   * activity in the Activity Manager window.
   *
   * This attribute allows to associate default activity components
   * with custom XBL bindings. See |activity.xml| file for default
   * activity XBL bindings, and |activity.css| file for default binding
   * associations.
   */
  /* attribute AString bindingName; */
  NS_SCRIPTABLE NS_IMETHOD GetBindingName(nsAString & aBindingName) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetBindingName(const nsAString & aBindingName) = 0;

  /**
   * Defines the grouping style of the activity when being shown in the
   * activity manager window:
   *  GROUPING_STYLE_STANDALONE or GROUPING_STYLE_BYCONTEXT
   */
  /* attribute short groupingStyle; */
  NS_SCRIPTABLE NS_IMETHOD GetGroupingStyle(PRInt16 *aGroupingStyle) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetGroupingStyle(PRInt16 aGroupingStyle) = 0;

  /**
   * A text value to associate a facet type with the activity. If empty,
   * the activity will be shown in the 'Misc' section.
   */
  /* attribute AString facet; */
  NS_SCRIPTABLE NS_IMETHOD GetFacet(nsAString & aFacet) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetFacet(const nsAString & aFacet) = 0;

  /**
   * Gets the initiator of the activity. An initiator represents an object
   * that generates and controls the activity. For example, Copy Service can be
   * the initiator of the copy, and move activities. Similarly Gloda can be the
   * initiator of indexing activity, etc.
   *
   * This attribute is used mostly by handler components to change the execution
   * flow of the activity such as canceling, pausing etc. Since not used by the
   * Activity Manager, it is not mandatory to set it.
   *
   * An initiator can be any JS Object or an XPCOM component that provides an
   * nsIVariant interface.
   */
  /* readonly attribute nsIVariant initiator; */
  NS_SCRIPTABLE NS_IMETHOD GetInitiator(nsIVariant **aInitiator) = 0;

  /**
   * Adds an object to the activity's internal subject list. Subject list
   * provides argument(s) to activity handlers to complete their operation.
   * For example, nsIActivityUndoHandler needs the source and destination
   * folders to undo a move operation.
   *
   * Since subjects are not used by the Activity Manager, it is up to the
   * activity developer to provide these objects.
   *
   * A subject can be any JS object or XPCOM component that supports nsIVariant
   * interface.
   */
  /* void addSubject (in nsIVariant aSubject); */
  NS_SCRIPTABLE NS_IMETHOD AddSubject(nsIVariant *aSubject) = 0;

  /**
   * Retrieves all subjects associated with this activity.
   *
   * @return The list of subject objects associated by the activity.
   */
  /* void getSubjects (out unsigned long length, [array, retval, size_is (length)] out nsIVariant aSubjects); */
  NS_SCRIPTABLE NS_IMETHOD GetSubjects(PRUint32 *length NS_OUTPARAM, nsIVariant ***aSubjects NS_OUTPARAM) = 0;

  /**
   * Sets and gets the context object of the activity. A context object can be
   * any JS object or XPCOM component that supports nsIVariant interface.
   */
  /* attribute nsIVariant contextObj; */
  NS_SCRIPTABLE NS_IMETHOD GetContextObj(nsIVariant **aContextObj) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetContextObj(nsIVariant *aContextObj) = 0;

  /**
   * Sets and gets the context type of the activity. If this is set, then
   * the contextDisplayText should also be set.
   */
  /* attribute AString contextType; */
  NS_SCRIPTABLE NS_IMETHOD GetContextType(nsAString & aContextType) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetContextType(const nsAString & aContextType) = 0;

  /**
   * Return the displayText to be used for the context
   **/
  /* attribute AString contextDisplayText; */
  NS_SCRIPTABLE NS_IMETHOD GetContextDisplayText(nsAString & aContextDisplayText) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetContextDisplayText(const nsAString & aContextDisplayText) = 0;

  /**
   * Adds a listener. See nsIActivityListener below.
   */
  /* void addListener (in nsIActivityListener aListener); */
  NS_SCRIPTABLE NS_IMETHOD AddListener(nsIActivityListener *aListener) = 0;

  /**
   * Removes the given listener. See nsIActivityListener below.
   */
  /* void removeListener (in nsIActivityListener aListener); */
  NS_SCRIPTABLE NS_IMETHOD RemoveListener(nsIActivityListener *aListener) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIActivity, NS_IACTIVITY_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIACTIVITY \
  NS_SCRIPTABLE NS_IMETHOD GetId(PRUint32 *aId); \
  NS_SCRIPTABLE NS_IMETHOD SetId(PRUint32 aId); \
  NS_SCRIPTABLE NS_IMETHOD GetDisplayText(nsAString & aDisplayText); \
  NS_SCRIPTABLE NS_IMETHOD GetIconClass(nsAString & aIconClass); \
  NS_SCRIPTABLE NS_IMETHOD SetIconClass(const nsAString & aIconClass); \
  NS_SCRIPTABLE NS_IMETHOD GetBindingName(nsAString & aBindingName); \
  NS_SCRIPTABLE NS_IMETHOD SetBindingName(const nsAString & aBindingName); \
  NS_SCRIPTABLE NS_IMETHOD GetGroupingStyle(PRInt16 *aGroupingStyle); \
  NS_SCRIPTABLE NS_IMETHOD SetGroupingStyle(PRInt16 aGroupingStyle); \
  NS_SCRIPTABLE NS_IMETHOD GetFacet(nsAString & aFacet); \
  NS_SCRIPTABLE NS_IMETHOD SetFacet(const nsAString & aFacet); \
  NS_SCRIPTABLE NS_IMETHOD GetInitiator(nsIVariant **aInitiator); \
  NS_SCRIPTABLE NS_IMETHOD AddSubject(nsIVariant *aSubject); \
  NS_SCRIPTABLE NS_IMETHOD GetSubjects(PRUint32 *length NS_OUTPARAM, nsIVariant ***aSubjects NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD GetContextObj(nsIVariant **aContextObj); \
  NS_SCRIPTABLE NS_IMETHOD SetContextObj(nsIVariant *aContextObj); \
  NS_SCRIPTABLE NS_IMETHOD GetContextType(nsAString & aContextType); \
  NS_SCRIPTABLE NS_IMETHOD SetContextType(const nsAString & aContextType); \
  NS_SCRIPTABLE NS_IMETHOD GetContextDisplayText(nsAString & aContextDisplayText); \
  NS_SCRIPTABLE NS_IMETHOD SetContextDisplayText(const nsAString & aContextDisplayText); \
  NS_SCRIPTABLE NS_IMETHOD AddListener(nsIActivityListener *aListener); \
  NS_SCRIPTABLE NS_IMETHOD RemoveListener(nsIActivityListener *aListener); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIACTIVITY(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetId(PRUint32 *aId) { return _to GetId(aId); } \
  NS_SCRIPTABLE NS_IMETHOD SetId(PRUint32 aId) { return _to SetId(aId); } \
  NS_SCRIPTABLE NS_IMETHOD GetDisplayText(nsAString & aDisplayText) { return _to GetDisplayText(aDisplayText); } \
  NS_SCRIPTABLE NS_IMETHOD GetIconClass(nsAString & aIconClass) { return _to GetIconClass(aIconClass); } \
  NS_SCRIPTABLE NS_IMETHOD SetIconClass(const nsAString & aIconClass) { return _to SetIconClass(aIconClass); } \
  NS_SCRIPTABLE NS_IMETHOD GetBindingName(nsAString & aBindingName) { return _to GetBindingName(aBindingName); } \
  NS_SCRIPTABLE NS_IMETHOD SetBindingName(const nsAString & aBindingName) { return _to SetBindingName(aBindingName); } \
  NS_SCRIPTABLE NS_IMETHOD GetGroupingStyle(PRInt16 *aGroupingStyle) { return _to GetGroupingStyle(aGroupingStyle); } \
  NS_SCRIPTABLE NS_IMETHOD SetGroupingStyle(PRInt16 aGroupingStyle) { return _to SetGroupingStyle(aGroupingStyle); } \
  NS_SCRIPTABLE NS_IMETHOD GetFacet(nsAString & aFacet) { return _to GetFacet(aFacet); } \
  NS_SCRIPTABLE NS_IMETHOD SetFacet(const nsAString & aFacet) { return _to SetFacet(aFacet); } \
  NS_SCRIPTABLE NS_IMETHOD GetInitiator(nsIVariant **aInitiator) { return _to GetInitiator(aInitiator); } \
  NS_SCRIPTABLE NS_IMETHOD AddSubject(nsIVariant *aSubject) { return _to AddSubject(aSubject); } \
  NS_SCRIPTABLE NS_IMETHOD GetSubjects(PRUint32 *length NS_OUTPARAM, nsIVariant ***aSubjects NS_OUTPARAM) { return _to GetSubjects(length, aSubjects); } \
  NS_SCRIPTABLE NS_IMETHOD GetContextObj(nsIVariant **aContextObj) { return _to GetContextObj(aContextObj); } \
  NS_SCRIPTABLE NS_IMETHOD SetContextObj(nsIVariant *aContextObj) { return _to SetContextObj(aContextObj); } \
  NS_SCRIPTABLE NS_IMETHOD GetContextType(nsAString & aContextType) { return _to GetContextType(aContextType); } \
  NS_SCRIPTABLE NS_IMETHOD SetContextType(const nsAString & aContextType) { return _to SetContextType(aContextType); } \
  NS_SCRIPTABLE NS_IMETHOD GetContextDisplayText(nsAString & aContextDisplayText) { return _to GetContextDisplayText(aContextDisplayText); } \
  NS_SCRIPTABLE NS_IMETHOD SetContextDisplayText(const nsAString & aContextDisplayText) { return _to SetContextDisplayText(aContextDisplayText); } \
  NS_SCRIPTABLE NS_IMETHOD AddListener(nsIActivityListener *aListener) { return _to AddListener(aListener); } \
  NS_SCRIPTABLE NS_IMETHOD RemoveListener(nsIActivityListener *aListener) { return _to RemoveListener(aListener); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIACTIVITY(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetId(PRUint32 *aId) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetId(aId); } \
  NS_SCRIPTABLE NS_IMETHOD SetId(PRUint32 aId) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetId(aId); } \
  NS_SCRIPTABLE NS_IMETHOD GetDisplayText(nsAString & aDisplayText) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDisplayText(aDisplayText); } \
  NS_SCRIPTABLE NS_IMETHOD GetIconClass(nsAString & aIconClass) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIconClass(aIconClass); } \
  NS_SCRIPTABLE NS_IMETHOD SetIconClass(const nsAString & aIconClass) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetIconClass(aIconClass); } \
  NS_SCRIPTABLE NS_IMETHOD GetBindingName(nsAString & aBindingName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBindingName(aBindingName); } \
  NS_SCRIPTABLE NS_IMETHOD SetBindingName(const nsAString & aBindingName) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetBindingName(aBindingName); } \
  NS_SCRIPTABLE NS_IMETHOD GetGroupingStyle(PRInt16 *aGroupingStyle) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetGroupingStyle(aGroupingStyle); } \
  NS_SCRIPTABLE NS_IMETHOD SetGroupingStyle(PRInt16 aGroupingStyle) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetGroupingStyle(aGroupingStyle); } \
  NS_SCRIPTABLE NS_IMETHOD GetFacet(nsAString & aFacet) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFacet(aFacet); } \
  NS_SCRIPTABLE NS_IMETHOD SetFacet(const nsAString & aFacet) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetFacet(aFacet); } \
  NS_SCRIPTABLE NS_IMETHOD GetInitiator(nsIVariant **aInitiator) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetInitiator(aInitiator); } \
  NS_SCRIPTABLE NS_IMETHOD AddSubject(nsIVariant *aSubject) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddSubject(aSubject); } \
  NS_SCRIPTABLE NS_IMETHOD GetSubjects(PRUint32 *length NS_OUTPARAM, nsIVariant ***aSubjects NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSubjects(length, aSubjects); } \
  NS_SCRIPTABLE NS_IMETHOD GetContextObj(nsIVariant **aContextObj) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetContextObj(aContextObj); } \
  NS_SCRIPTABLE NS_IMETHOD SetContextObj(nsIVariant *aContextObj) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetContextObj(aContextObj); } \
  NS_SCRIPTABLE NS_IMETHOD GetContextType(nsAString & aContextType) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetContextType(aContextType); } \
  NS_SCRIPTABLE NS_IMETHOD SetContextType(const nsAString & aContextType) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetContextType(aContextType); } \
  NS_SCRIPTABLE NS_IMETHOD GetContextDisplayText(nsAString & aContextDisplayText) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetContextDisplayText(aContextDisplayText); } \
  NS_SCRIPTABLE NS_IMETHOD SetContextDisplayText(const nsAString & aContextDisplayText) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetContextDisplayText(aContextDisplayText); } \
  NS_SCRIPTABLE NS_IMETHOD AddListener(nsIActivityListener *aListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddListener(aListener); } \
  NS_SCRIPTABLE NS_IMETHOD RemoveListener(nsIActivityListener *aListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveListener(aListener); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsActivity : public nsIActivity
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIACTIVITY

  nsActivity();

private:
  ~nsActivity();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsActivity, nsIActivity)

nsActivity::nsActivity()
{
  /* member initializers and constructor code */
}

nsActivity::~nsActivity()
{
  /* destructor code */
}

/* attribute unsigned long id; */
NS_IMETHODIMP nsActivity::GetId(PRUint32 *aId)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsActivity::SetId(PRUint32 aId)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString displayText; */
NS_IMETHODIMP nsActivity::GetDisplayText(nsAString & aDisplayText)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AString iconClass; */
NS_IMETHODIMP nsActivity::GetIconClass(nsAString & aIconClass)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsActivity::SetIconClass(const nsAString & aIconClass)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AString bindingName; */
NS_IMETHODIMP nsActivity::GetBindingName(nsAString & aBindingName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsActivity::SetBindingName(const nsAString & aBindingName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute short groupingStyle; */
NS_IMETHODIMP nsActivity::GetGroupingStyle(PRInt16 *aGroupingStyle)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsActivity::SetGroupingStyle(PRInt16 aGroupingStyle)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AString facet; */
NS_IMETHODIMP nsActivity::GetFacet(nsAString & aFacet)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsActivity::SetFacet(const nsAString & aFacet)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIVariant initiator; */
NS_IMETHODIMP nsActivity::GetInitiator(nsIVariant **aInitiator)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addSubject (in nsIVariant aSubject); */
NS_IMETHODIMP nsActivity::AddSubject(nsIVariant *aSubject)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getSubjects (out unsigned long length, [array, retval, size_is (length)] out nsIVariant aSubjects); */
NS_IMETHODIMP nsActivity::GetSubjects(PRUint32 *length NS_OUTPARAM, nsIVariant ***aSubjects NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIVariant contextObj; */
NS_IMETHODIMP nsActivity::GetContextObj(nsIVariant **aContextObj)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsActivity::SetContextObj(nsIVariant *aContextObj)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AString contextType; */
NS_IMETHODIMP nsActivity::GetContextType(nsAString & aContextType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsActivity::SetContextType(const nsAString & aContextType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AString contextDisplayText; */
NS_IMETHODIMP nsActivity::GetContextDisplayText(nsAString & aContextDisplayText)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsActivity::SetContextDisplayText(const nsAString & aContextDisplayText)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addListener (in nsIActivityListener aListener); */
NS_IMETHODIMP nsActivity::AddListener(nsIActivityListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeListener (in nsIActivityListener aListener); */
NS_IMETHODIMP nsActivity::RemoveListener(nsIActivityListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIActivityProcess */
#define NS_IACTIVITYPROCESS_IID_STR "9dc7ca67-828d-4afd-a5c6-3ece091a98b8"

#define NS_IACTIVITYPROCESS_IID \
  {0x9dc7ca67, 0x828d, 0x4afd, \
    { 0xa5, 0xc6, 0x3e, 0xce, 0x09, 0x1a, 0x98, 0xb8 }}

class NS_NO_VTABLE NS_SCRIPTABLE nsIActivityProcess : public nsIActivity {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IACTIVITYPROCESS_IID)

  /**
 * A Process represents an on-going activity.
 */
/**
   * Default state for uninitialized process activity
   * object.
   */
  enum { STATE_NOTSTARTED = -1 };

  /**
   * Activity is currently in progress.
   */
  enum { STATE_INPROGRESS = 0 };

  /**
   * Activity is completed.
   */
  enum { STATE_COMPLETED = 1 };

  /**
   * Activity was canceled by the user.
   * (same as completed)
   */
  enum { STATE_CANCELED = 2 };

  /**
   * Activity was paused by the user.
   */
  enum { STATE_PAUSED = 3 };

  /**
   * Activity waits for the user input's to retry.
   * (i.e. login password)
   */
  enum { STATE_WAITINGFORINPUT = 4 };

  /**
   * Activity is ready for an automatic or manual retry.
   */
  enum { STATE_WAITINGFORRETRY = 5 };

  /**
   * The state of the activity.
   * See above for possible values.
   * @exception NS_ERROR_ILLEGAL_VALUE if the state isn't one of the states
   *   defined above.
   */
  /* attribute short state; */
  NS_SCRIPTABLE NS_IMETHOD GetState(PRInt16 *aState) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetState(PRInt16 aState) = 0;

  /**
   * The percentage of activity completed.
   * If the max value is unknown it'll be -1 here.
   */
  /* readonly attribute long percentComplete; */
  NS_SCRIPTABLE NS_IMETHOD GetPercentComplete(PRInt32 *aPercentComplete) = 0;

  /**
   * A brief text about the process' status.
   */
  /* readonly attribute AString lastStatusText; */
  NS_SCRIPTABLE NS_IMETHOD GetLastStatusText(nsAString & aLastStatusText) = 0;

  /**
   * The amount of work units completed so far.
   */
  /* readonly attribute unsigned long workUnitComplete; */
  NS_SCRIPTABLE NS_IMETHOD GetWorkUnitComplete(PRUint32 *aWorkUnitComplete) = 0;

  /**
   * Total amount of work units.
   */
  /* readonly attribute unsigned long totalWorkUnits; */
  NS_SCRIPTABLE NS_IMETHOD GetTotalWorkUnits(PRUint32 *aTotalWorkUnits) = 0;

  /**
   * The starting time of the process.
   * 64-bit signed integers relative to midnight (00:00:00), January 1, 1970
   * Greenwich Mean Time (GMT). (GMT is also known as Coordinated Universal
   * Time, UTC.). The units of time are in microseconds.
   *
   * In JS Date.now(), in C++ PR_Now() / PR_USEC_PER_MSEC can be used to set
   * this value.
   */
  /* readonly attribute long long startTime; */
  NS_SCRIPTABLE NS_IMETHOD GetStartTime(PRInt64 *aStartTime) = 0;

  /**
   * The handler to invoke when the cancel button is pressed. If present
   * (non-null), the activity can be canceled and a cancel button will be
   * displayed to the user.  If null, it cannot be canceled and no button will
   * be displayed.
   */
  /* attribute nsIActivityCancelHandler cancelHandler; */
  NS_SCRIPTABLE NS_IMETHOD GetCancelHandler(nsIActivityCancelHandler **aCancelHandler) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetCancelHandler(nsIActivityCancelHandler *aCancelHandler) = 0;

  /**
   * The handler to invoke when the pause button is pressed. If present
   * (non-null), the activity can be pauseable and a pause button will be
   * displayed to the user.  If null, it cannot be paused and no button will
   * be displayed.
   */
  /* attribute nsIActivityPauseHandler pauseHandler; */
  NS_SCRIPTABLE NS_IMETHOD GetPauseHandler(nsIActivityPauseHandler **aPauseHandler) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetPauseHandler(nsIActivityPauseHandler *aPauseHandler) = 0;

  /**
   * The handler to invoke when the retry button is pressed. If present
   * (non-null), the activity can be retryable and a retry button will be
   * displayed to the user.  If null, it cannot be retried and no button will
   * be displayed.
   */
  /* attribute nsIActivityRetryHandler retryHandler; */
  NS_SCRIPTABLE NS_IMETHOD GetRetryHandler(nsIActivityRetryHandler **aRetryHandler) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetRetryHandler(nsIActivityRetryHandler *aRetryHandler) = 0;

  /**
   * Updates the activity progress info.
   *
   * @param aStatusText A localized text describing the current status of the
   *                    process
   * @param aWorkUnitComplete The amount of work units completed. Not used by
   *                          Activity Manager or default binding for any
   *                          purpose.
   * @param aTotalWorkUnits Total amount of work units. Not used by
   *                        Activity Manager or default binding for any
   *                        purpose. If set to zero, this indicates that the
   *                        number of work units is unknown, and the percentage
   *                        attribute will be set to -1.
   */
  /* void setProgress (in AString aStatusText, in unsigned long aWorkUnitComplete, in unsigned long aTotalWorkUnits); */
  NS_SCRIPTABLE NS_IMETHOD SetProgress(const nsAString & aStatusText, PRUint32 aWorkUnitComplete, PRUint32 aTotalWorkUnits) = 0;

  /**
   * Component initialization method.
   *
   * @param aDisplayText A localized text to be shown on the Activity Manager
   *                     window
   * @param aInitiator The initiator of the process
   */
  /* void init (in AString aDisplayText, in nsIVariant aInitiator); */
  NS_SCRIPTABLE NS_IMETHOD Init(const nsAString & aDisplayText, nsIVariant *aInitiator) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIActivityProcess, NS_IACTIVITYPROCESS_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIACTIVITYPROCESS \
  NS_SCRIPTABLE NS_IMETHOD GetState(PRInt16 *aState); \
  NS_SCRIPTABLE NS_IMETHOD SetState(PRInt16 aState); \
  NS_SCRIPTABLE NS_IMETHOD GetPercentComplete(PRInt32 *aPercentComplete); \
  NS_SCRIPTABLE NS_IMETHOD GetLastStatusText(nsAString & aLastStatusText); \
  NS_SCRIPTABLE NS_IMETHOD GetWorkUnitComplete(PRUint32 *aWorkUnitComplete); \
  NS_SCRIPTABLE NS_IMETHOD GetTotalWorkUnits(PRUint32 *aTotalWorkUnits); \
  NS_SCRIPTABLE NS_IMETHOD GetStartTime(PRInt64 *aStartTime); \
  NS_SCRIPTABLE NS_IMETHOD GetCancelHandler(nsIActivityCancelHandler **aCancelHandler); \
  NS_SCRIPTABLE NS_IMETHOD SetCancelHandler(nsIActivityCancelHandler *aCancelHandler); \
  NS_SCRIPTABLE NS_IMETHOD GetPauseHandler(nsIActivityPauseHandler **aPauseHandler); \
  NS_SCRIPTABLE NS_IMETHOD SetPauseHandler(nsIActivityPauseHandler *aPauseHandler); \
  NS_SCRIPTABLE NS_IMETHOD GetRetryHandler(nsIActivityRetryHandler **aRetryHandler); \
  NS_SCRIPTABLE NS_IMETHOD SetRetryHandler(nsIActivityRetryHandler *aRetryHandler); \
  NS_SCRIPTABLE NS_IMETHOD SetProgress(const nsAString & aStatusText, PRUint32 aWorkUnitComplete, PRUint32 aTotalWorkUnits); \
  NS_SCRIPTABLE NS_IMETHOD Init(const nsAString & aDisplayText, nsIVariant *aInitiator); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIACTIVITYPROCESS(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetState(PRInt16 *aState) { return _to GetState(aState); } \
  NS_SCRIPTABLE NS_IMETHOD SetState(PRInt16 aState) { return _to SetState(aState); } \
  NS_SCRIPTABLE NS_IMETHOD GetPercentComplete(PRInt32 *aPercentComplete) { return _to GetPercentComplete(aPercentComplete); } \
  NS_SCRIPTABLE NS_IMETHOD GetLastStatusText(nsAString & aLastStatusText) { return _to GetLastStatusText(aLastStatusText); } \
  NS_SCRIPTABLE NS_IMETHOD GetWorkUnitComplete(PRUint32 *aWorkUnitComplete) { return _to GetWorkUnitComplete(aWorkUnitComplete); } \
  NS_SCRIPTABLE NS_IMETHOD GetTotalWorkUnits(PRUint32 *aTotalWorkUnits) { return _to GetTotalWorkUnits(aTotalWorkUnits); } \
  NS_SCRIPTABLE NS_IMETHOD GetStartTime(PRInt64 *aStartTime) { return _to GetStartTime(aStartTime); } \
  NS_SCRIPTABLE NS_IMETHOD GetCancelHandler(nsIActivityCancelHandler **aCancelHandler) { return _to GetCancelHandler(aCancelHandler); } \
  NS_SCRIPTABLE NS_IMETHOD SetCancelHandler(nsIActivityCancelHandler *aCancelHandler) { return _to SetCancelHandler(aCancelHandler); } \
  NS_SCRIPTABLE NS_IMETHOD GetPauseHandler(nsIActivityPauseHandler **aPauseHandler) { return _to GetPauseHandler(aPauseHandler); } \
  NS_SCRIPTABLE NS_IMETHOD SetPauseHandler(nsIActivityPauseHandler *aPauseHandler) { return _to SetPauseHandler(aPauseHandler); } \
  NS_SCRIPTABLE NS_IMETHOD GetRetryHandler(nsIActivityRetryHandler **aRetryHandler) { return _to GetRetryHandler(aRetryHandler); } \
  NS_SCRIPTABLE NS_IMETHOD SetRetryHandler(nsIActivityRetryHandler *aRetryHandler) { return _to SetRetryHandler(aRetryHandler); } \
  NS_SCRIPTABLE NS_IMETHOD SetProgress(const nsAString & aStatusText, PRUint32 aWorkUnitComplete, PRUint32 aTotalWorkUnits) { return _to SetProgress(aStatusText, aWorkUnitComplete, aTotalWorkUnits); } \
  NS_SCRIPTABLE NS_IMETHOD Init(const nsAString & aDisplayText, nsIVariant *aInitiator) { return _to Init(aDisplayText, aInitiator); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIACTIVITYPROCESS(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetState(PRInt16 *aState) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetState(aState); } \
  NS_SCRIPTABLE NS_IMETHOD SetState(PRInt16 aState) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetState(aState); } \
  NS_SCRIPTABLE NS_IMETHOD GetPercentComplete(PRInt32 *aPercentComplete) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPercentComplete(aPercentComplete); } \
  NS_SCRIPTABLE NS_IMETHOD GetLastStatusText(nsAString & aLastStatusText) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLastStatusText(aLastStatusText); } \
  NS_SCRIPTABLE NS_IMETHOD GetWorkUnitComplete(PRUint32 *aWorkUnitComplete) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetWorkUnitComplete(aWorkUnitComplete); } \
  NS_SCRIPTABLE NS_IMETHOD GetTotalWorkUnits(PRUint32 *aTotalWorkUnits) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTotalWorkUnits(aTotalWorkUnits); } \
  NS_SCRIPTABLE NS_IMETHOD GetStartTime(PRInt64 *aStartTime) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStartTime(aStartTime); } \
  NS_SCRIPTABLE NS_IMETHOD GetCancelHandler(nsIActivityCancelHandler **aCancelHandler) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCancelHandler(aCancelHandler); } \
  NS_SCRIPTABLE NS_IMETHOD SetCancelHandler(nsIActivityCancelHandler *aCancelHandler) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetCancelHandler(aCancelHandler); } \
  NS_SCRIPTABLE NS_IMETHOD GetPauseHandler(nsIActivityPauseHandler **aPauseHandler) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPauseHandler(aPauseHandler); } \
  NS_SCRIPTABLE NS_IMETHOD SetPauseHandler(nsIActivityPauseHandler *aPauseHandler) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetPauseHandler(aPauseHandler); } \
  NS_SCRIPTABLE NS_IMETHOD GetRetryHandler(nsIActivityRetryHandler **aRetryHandler) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRetryHandler(aRetryHandler); } \
  NS_SCRIPTABLE NS_IMETHOD SetRetryHandler(nsIActivityRetryHandler *aRetryHandler) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetRetryHandler(aRetryHandler); } \
  NS_SCRIPTABLE NS_IMETHOD SetProgress(const nsAString & aStatusText, PRUint32 aWorkUnitComplete, PRUint32 aTotalWorkUnits) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetProgress(aStatusText, aWorkUnitComplete, aTotalWorkUnits); } \
  NS_SCRIPTABLE NS_IMETHOD Init(const nsAString & aDisplayText, nsIVariant *aInitiator) { return !_to ? NS_ERROR_NULL_POINTER : _to->Init(aDisplayText, aInitiator); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsActivityProcess : public nsIActivityProcess
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIACTIVITYPROCESS

  nsActivityProcess();

private:
  ~nsActivityProcess();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsActivityProcess, nsIActivityProcess)

nsActivityProcess::nsActivityProcess()
{
  /* member initializers and constructor code */
}

nsActivityProcess::~nsActivityProcess()
{
  /* destructor code */
}

/* attribute short state; */
NS_IMETHODIMP nsActivityProcess::GetState(PRInt16 *aState)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsActivityProcess::SetState(PRInt16 aState)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long percentComplete; */
NS_IMETHODIMP nsActivityProcess::GetPercentComplete(PRInt32 *aPercentComplete)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString lastStatusText; */
NS_IMETHODIMP nsActivityProcess::GetLastStatusText(nsAString & aLastStatusText)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned long workUnitComplete; */
NS_IMETHODIMP nsActivityProcess::GetWorkUnitComplete(PRUint32 *aWorkUnitComplete)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned long totalWorkUnits; */
NS_IMETHODIMP nsActivityProcess::GetTotalWorkUnits(PRUint32 *aTotalWorkUnits)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long long startTime; */
NS_IMETHODIMP nsActivityProcess::GetStartTime(PRInt64 *aStartTime)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIActivityCancelHandler cancelHandler; */
NS_IMETHODIMP nsActivityProcess::GetCancelHandler(nsIActivityCancelHandler **aCancelHandler)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsActivityProcess::SetCancelHandler(nsIActivityCancelHandler *aCancelHandler)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIActivityPauseHandler pauseHandler; */
NS_IMETHODIMP nsActivityProcess::GetPauseHandler(nsIActivityPauseHandler **aPauseHandler)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsActivityProcess::SetPauseHandler(nsIActivityPauseHandler *aPauseHandler)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIActivityRetryHandler retryHandler; */
NS_IMETHODIMP nsActivityProcess::GetRetryHandler(nsIActivityRetryHandler **aRetryHandler)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsActivityProcess::SetRetryHandler(nsIActivityRetryHandler *aRetryHandler)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setProgress (in AString aStatusText, in unsigned long aWorkUnitComplete, in unsigned long aTotalWorkUnits); */
NS_IMETHODIMP nsActivityProcess::SetProgress(const nsAString & aStatusText, PRUint32 aWorkUnitComplete, PRUint32 aTotalWorkUnits)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void init (in AString aDisplayText, in nsIVariant aInitiator); */
NS_IMETHODIMP nsActivityProcess::Init(const nsAString & aDisplayText, nsIVariant *aInitiator)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIActivityEvent */
#define NS_IACTIVITYEVENT_IID_STR "5b1b0d03-2820-4e37-8bf8-102afde4fc45"

#define NS_IACTIVITYEVENT_IID \
  {0x5b1b0d03, 0x2820, 0x4e37, \
    { 0x8b, 0xf8, 0x10, 0x2a, 0xfd, 0xe4, 0xfc, 0x45 }}

class NS_NO_VTABLE NS_SCRIPTABLE nsIActivityEvent : public nsIActivity {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IACTIVITYEVENT_IID)

  /**
 * Historical actions performed by the user, by extensions or by the system.
 */
/**
   * Any localized textual information related to this event.
   * It is shown at the bottom of the displayText area.
   */
  /* readonly attribute AString statusText; */
  NS_SCRIPTABLE NS_IMETHOD GetStatusText(nsAString & aStatusText) = 0;

  /**
   * The starting time of the event.
   * 64-bit signed integers relative to midnight (00:00:00), January 1, 1970
   * Greenwich Mean Time (GMT). (GMT is also known as Coordinated Universal
   * Time, UTC.). The units of time are in microseconds.
   *
   * In JS Date.now(), in C++ PR_Now() / PR_USEC_PER_MSEC can be used to set
   * this value.
   */
  /* readonly attribute long long startTime; */
  NS_SCRIPTABLE NS_IMETHOD GetStartTime(PRInt64 *aStartTime) = 0;

  /**
   * The completion time of the event in microseconds.
   * 64-bit signed integers relative to midnight (00:00:00), January 1, 1970
   * Greenwich Mean Time (GMT). (GMT is also known as Coordinated Universal
   * Time, UTC.). The units of time are in microseconds.
   *
   * In JS Date.now(), in C++ PR_Now() / PR_USEC_PER_MSEC can be used to set
   * this value.
   */
  /* readonly attribute long long completionTime; */
  NS_SCRIPTABLE NS_IMETHOD GetCompletionTime(PRInt64 *aCompletionTime) = 0;

  /**
   * The handler to invoke when the undo button is pressed.  If present
   * (non-null), the activity can be undoable and an undo button will be
   * displayed to the user.  If null, it cannot be undone and no button will
   * be displayed.
   */
  /* attribute nsIActivityUndoHandler undoHandler; */
  NS_SCRIPTABLE NS_IMETHOD GetUndoHandler(nsIActivityUndoHandler **aUndoHandler) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetUndoHandler(nsIActivityUndoHandler *aUndoHandler) = 0;

  /**
   * Component initialization method.
   *
   * @param aDisplayText Any localized text describing the event and its context
   * @param aInitiator The initiator of the event
   * @param aStatusText Any localized additional information about the event
   * @param aStartTime The starting time of the event
   * @param aCompletionTime The completion time of the event
   */
  /* void init (in AString aDisplayText, in nsIVariant aInitiator, in AString aStatusText, in long long aStartTime, in long long aCompletionTime); */
  NS_SCRIPTABLE NS_IMETHOD Init(const nsAString & aDisplayText, nsIVariant *aInitiator, const nsAString & aStatusText, PRInt64 aStartTime, PRInt64 aCompletionTime) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIActivityEvent, NS_IACTIVITYEVENT_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIACTIVITYEVENT \
  NS_SCRIPTABLE NS_IMETHOD GetStatusText(nsAString & aStatusText); \
  NS_SCRIPTABLE NS_IMETHOD GetStartTime(PRInt64 *aStartTime); \
  NS_SCRIPTABLE NS_IMETHOD GetCompletionTime(PRInt64 *aCompletionTime); \
  NS_SCRIPTABLE NS_IMETHOD GetUndoHandler(nsIActivityUndoHandler **aUndoHandler); \
  NS_SCRIPTABLE NS_IMETHOD SetUndoHandler(nsIActivityUndoHandler *aUndoHandler); \
  NS_SCRIPTABLE NS_IMETHOD Init(const nsAString & aDisplayText, nsIVariant *aInitiator, const nsAString & aStatusText, PRInt64 aStartTime, PRInt64 aCompletionTime); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIACTIVITYEVENT(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetStatusText(nsAString & aStatusText) { return _to GetStatusText(aStatusText); } \
  NS_SCRIPTABLE NS_IMETHOD GetStartTime(PRInt64 *aStartTime) { return _to GetStartTime(aStartTime); } \
  NS_SCRIPTABLE NS_IMETHOD GetCompletionTime(PRInt64 *aCompletionTime) { return _to GetCompletionTime(aCompletionTime); } \
  NS_SCRIPTABLE NS_IMETHOD GetUndoHandler(nsIActivityUndoHandler **aUndoHandler) { return _to GetUndoHandler(aUndoHandler); } \
  NS_SCRIPTABLE NS_IMETHOD SetUndoHandler(nsIActivityUndoHandler *aUndoHandler) { return _to SetUndoHandler(aUndoHandler); } \
  NS_SCRIPTABLE NS_IMETHOD Init(const nsAString & aDisplayText, nsIVariant *aInitiator, const nsAString & aStatusText, PRInt64 aStartTime, PRInt64 aCompletionTime) { return _to Init(aDisplayText, aInitiator, aStatusText, aStartTime, aCompletionTime); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIACTIVITYEVENT(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetStatusText(nsAString & aStatusText) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStatusText(aStatusText); } \
  NS_SCRIPTABLE NS_IMETHOD GetStartTime(PRInt64 *aStartTime) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStartTime(aStartTime); } \
  NS_SCRIPTABLE NS_IMETHOD GetCompletionTime(PRInt64 *aCompletionTime) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCompletionTime(aCompletionTime); } \
  NS_SCRIPTABLE NS_IMETHOD GetUndoHandler(nsIActivityUndoHandler **aUndoHandler) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetUndoHandler(aUndoHandler); } \
  NS_SCRIPTABLE NS_IMETHOD SetUndoHandler(nsIActivityUndoHandler *aUndoHandler) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetUndoHandler(aUndoHandler); } \
  NS_SCRIPTABLE NS_IMETHOD Init(const nsAString & aDisplayText, nsIVariant *aInitiator, const nsAString & aStatusText, PRInt64 aStartTime, PRInt64 aCompletionTime) { return !_to ? NS_ERROR_NULL_POINTER : _to->Init(aDisplayText, aInitiator, aStatusText, aStartTime, aCompletionTime); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsActivityEvent : public nsIActivityEvent
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIACTIVITYEVENT

  nsActivityEvent();

private:
  ~nsActivityEvent();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsActivityEvent, nsIActivityEvent)

nsActivityEvent::nsActivityEvent()
{
  /* member initializers and constructor code */
}

nsActivityEvent::~nsActivityEvent()
{
  /* destructor code */
}

/* readonly attribute AString statusText; */
NS_IMETHODIMP nsActivityEvent::GetStatusText(nsAString & aStatusText)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long long startTime; */
NS_IMETHODIMP nsActivityEvent::GetStartTime(PRInt64 *aStartTime)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long long completionTime; */
NS_IMETHODIMP nsActivityEvent::GetCompletionTime(PRInt64 *aCompletionTime)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIActivityUndoHandler undoHandler; */
NS_IMETHODIMP nsActivityEvent::GetUndoHandler(nsIActivityUndoHandler **aUndoHandler)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsActivityEvent::SetUndoHandler(nsIActivityUndoHandler *aUndoHandler)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void init (in AString aDisplayText, in nsIVariant aInitiator, in AString aStatusText, in long long aStartTime, in long long aCompletionTime); */
NS_IMETHODIMP nsActivityEvent::Init(const nsAString & aDisplayText, nsIVariant *aInitiator, const nsAString & aStatusText, PRInt64 aStartTime, PRInt64 aCompletionTime)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIActivityWarning */
#define NS_IACTIVITYWARNING_IID_STR "8265833e-c604-4585-a43c-a76bd8ed3a8c"

#define NS_IACTIVITYWARNING_IID \
  {0x8265833e, 0xc604, 0x4585, \
    { 0xa4, 0x3c, 0xa7, 0x6b, 0xd8, 0xed, 0x3a, 0x8c }}

class NS_NO_VTABLE NS_SCRIPTABLE nsIActivityWarning : public nsIActivity {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IACTIVITYWARNING_IID)

  /**
   * Any localized textual information related to this warning.
   */
  /* readonly attribute AString warningText; */
  NS_SCRIPTABLE NS_IMETHOD GetWarningText(nsAString & aWarningText) = 0;

  /**
   * The time of the warning.
   * 64-bit signed integers relative to midnight (00:00:00), January 1, 1970
   * Greenwich Mean Time (GMT). (GMT is also known as Coordinated Universal
   * Time, UTC.). The units of time are in microseconds.
   *
   * In JS Date.now(), in C++ PR_Now() / PR_USEC_PER_MSEC can be used to set
   * this value.
   */
  /* readonly attribute long long time; */
  NS_SCRIPTABLE NS_IMETHOD GetTime(PRInt64 *aTime) = 0;

  /**
   * Recovery tip of the warning, localized.
   */
  /* readonly attribute AString recoveryTipText; */
  NS_SCRIPTABLE NS_IMETHOD GetRecoveryTipText(nsAString & aRecoveryTipText) = 0;

  /**
   * The handler to invoke when the recover button is pressed.  If present
   * (non-null), the activity can be recoverable and a recover button will be
   * displayed to the user.  If null, it cannot be recovered and no button will
   * be displayed.
   */
  /* attribute nsIActivityRecoveryHandler recoveryHandler; */
  NS_SCRIPTABLE NS_IMETHOD GetRecoveryHandler(nsIActivityRecoveryHandler **aRecoveryHandler) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetRecoveryHandler(nsIActivityRecoveryHandler *aRecoveryHandler) = 0;

  /**
   * Component initialization method.
   *
   * @param aWarningText The localized text that will be shown on the display
   *                     area
   * @param aInitiator The initiator of the warning
   * @param aRecoveryTip A localized textual information to guide the user in
   *                     order to recover from the warning situation.
   */
  /* void init (in AString aWarningText, in nsIVariant aInitiator, in AString aRecoveryTip); */
  NS_SCRIPTABLE NS_IMETHOD Init(const nsAString & aWarningText, nsIVariant *aInitiator, const nsAString & aRecoveryTip) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIActivityWarning, NS_IACTIVITYWARNING_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIACTIVITYWARNING \
  NS_SCRIPTABLE NS_IMETHOD GetWarningText(nsAString & aWarningText); \
  NS_SCRIPTABLE NS_IMETHOD GetTime(PRInt64 *aTime); \
  NS_SCRIPTABLE NS_IMETHOD GetRecoveryTipText(nsAString & aRecoveryTipText); \
  NS_SCRIPTABLE NS_IMETHOD GetRecoveryHandler(nsIActivityRecoveryHandler **aRecoveryHandler); \
  NS_SCRIPTABLE NS_IMETHOD SetRecoveryHandler(nsIActivityRecoveryHandler *aRecoveryHandler); \
  NS_SCRIPTABLE NS_IMETHOD Init(const nsAString & aWarningText, nsIVariant *aInitiator, const nsAString & aRecoveryTip); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIACTIVITYWARNING(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetWarningText(nsAString & aWarningText) { return _to GetWarningText(aWarningText); } \
  NS_SCRIPTABLE NS_IMETHOD GetTime(PRInt64 *aTime) { return _to GetTime(aTime); } \
  NS_SCRIPTABLE NS_IMETHOD GetRecoveryTipText(nsAString & aRecoveryTipText) { return _to GetRecoveryTipText(aRecoveryTipText); } \
  NS_SCRIPTABLE NS_IMETHOD GetRecoveryHandler(nsIActivityRecoveryHandler **aRecoveryHandler) { return _to GetRecoveryHandler(aRecoveryHandler); } \
  NS_SCRIPTABLE NS_IMETHOD SetRecoveryHandler(nsIActivityRecoveryHandler *aRecoveryHandler) { return _to SetRecoveryHandler(aRecoveryHandler); } \
  NS_SCRIPTABLE NS_IMETHOD Init(const nsAString & aWarningText, nsIVariant *aInitiator, const nsAString & aRecoveryTip) { return _to Init(aWarningText, aInitiator, aRecoveryTip); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIACTIVITYWARNING(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetWarningText(nsAString & aWarningText) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetWarningText(aWarningText); } \
  NS_SCRIPTABLE NS_IMETHOD GetTime(PRInt64 *aTime) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTime(aTime); } \
  NS_SCRIPTABLE NS_IMETHOD GetRecoveryTipText(nsAString & aRecoveryTipText) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRecoveryTipText(aRecoveryTipText); } \
  NS_SCRIPTABLE NS_IMETHOD GetRecoveryHandler(nsIActivityRecoveryHandler **aRecoveryHandler) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRecoveryHandler(aRecoveryHandler); } \
  NS_SCRIPTABLE NS_IMETHOD SetRecoveryHandler(nsIActivityRecoveryHandler *aRecoveryHandler) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetRecoveryHandler(aRecoveryHandler); } \
  NS_SCRIPTABLE NS_IMETHOD Init(const nsAString & aWarningText, nsIVariant *aInitiator, const nsAString & aRecoveryTip) { return !_to ? NS_ERROR_NULL_POINTER : _to->Init(aWarningText, aInitiator, aRecoveryTip); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsActivityWarning : public nsIActivityWarning
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIACTIVITYWARNING

  nsActivityWarning();

private:
  ~nsActivityWarning();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsActivityWarning, nsIActivityWarning)

nsActivityWarning::nsActivityWarning()
{
  /* member initializers and constructor code */
}

nsActivityWarning::~nsActivityWarning()
{
  /* destructor code */
}

/* readonly attribute AString warningText; */
NS_IMETHODIMP nsActivityWarning::GetWarningText(nsAString & aWarningText)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long long time; */
NS_IMETHODIMP nsActivityWarning::GetTime(PRInt64 *aTime)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString recoveryTipText; */
NS_IMETHODIMP nsActivityWarning::GetRecoveryTipText(nsAString & aRecoveryTipText)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIActivityRecoveryHandler recoveryHandler; */
NS_IMETHODIMP nsActivityWarning::GetRecoveryHandler(nsIActivityRecoveryHandler **aRecoveryHandler)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsActivityWarning::SetRecoveryHandler(nsIActivityRecoveryHandler *aRecoveryHandler)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void init (in AString aWarningText, in nsIVariant aInitiator, in AString aRecoveryTip); */
NS_IMETHODIMP nsActivityWarning::Init(const nsAString & aWarningText, nsIVariant *aInitiator, const nsAString & aRecoveryTip)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIActivityListener */
#define NS_IACTIVITYLISTENER_IID_STR "bd11519f-b297-4b34-a793-1861dc90d5e9"

#define NS_IACTIVITYLISTENER_IID \
  {0xbd11519f, 0xb297, 0x4b34, \
    { 0xa7, 0x93, 0x18, 0x61, 0xdc, 0x90, 0xd5, 0xe9 }}

class NS_NO_VTABLE NS_SCRIPTABLE nsIActivityListener : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IACTIVITYLISTENER_IID)

  /**
   * Triggered after activity state is changed.
   */
  /* void onStateChanged (in nsIActivity aActivity, in short aOldState); */
  NS_SCRIPTABLE NS_IMETHOD OnStateChanged(nsIActivity *aActivity, PRInt16 aOldState) = 0;

  /**
   * Triggered after the progress of the process activity is changed.
   */
  /* void onProgressChanged (in nsIActivity aActivity, in AString aStatusText, in unsigned long aWorkUnitsCompleted, in unsigned long aTotalWorkUnits); */
  NS_SCRIPTABLE NS_IMETHOD OnProgressChanged(nsIActivity *aActivity, const nsAString & aStatusText, PRUint32 aWorkUnitsCompleted, PRUint32 aTotalWorkUnits) = 0;

  /**
   * Triggered after one of the activity handler is set.
   *
   * This is mostly used to update the UI of the activity when
   * one of the handler is set to null after the operation is completed.
   * For example after the activity is undoed, to make the undo button
   * invisible.
   */
  /* void onHandlerChanged (in nsIActivity aActivity); */
  NS_SCRIPTABLE NS_IMETHOD OnHandlerChanged(nsIActivity *aActivity) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIActivityListener, NS_IACTIVITYLISTENER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIACTIVITYLISTENER \
  NS_SCRIPTABLE NS_IMETHOD OnStateChanged(nsIActivity *aActivity, PRInt16 aOldState); \
  NS_SCRIPTABLE NS_IMETHOD OnProgressChanged(nsIActivity *aActivity, const nsAString & aStatusText, PRUint32 aWorkUnitsCompleted, PRUint32 aTotalWorkUnits); \
  NS_SCRIPTABLE NS_IMETHOD OnHandlerChanged(nsIActivity *aActivity); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIACTIVITYLISTENER(_to) \
  NS_SCRIPTABLE NS_IMETHOD OnStateChanged(nsIActivity *aActivity, PRInt16 aOldState) { return _to OnStateChanged(aActivity, aOldState); } \
  NS_SCRIPTABLE NS_IMETHOD OnProgressChanged(nsIActivity *aActivity, const nsAString & aStatusText, PRUint32 aWorkUnitsCompleted, PRUint32 aTotalWorkUnits) { return _to OnProgressChanged(aActivity, aStatusText, aWorkUnitsCompleted, aTotalWorkUnits); } \
  NS_SCRIPTABLE NS_IMETHOD OnHandlerChanged(nsIActivity *aActivity) { return _to OnHandlerChanged(aActivity); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIACTIVITYLISTENER(_to) \
  NS_SCRIPTABLE NS_IMETHOD OnStateChanged(nsIActivity *aActivity, PRInt16 aOldState) { return !_to ? NS_ERROR_NULL_POINTER : _to->OnStateChanged(aActivity, aOldState); } \
  NS_SCRIPTABLE NS_IMETHOD OnProgressChanged(nsIActivity *aActivity, const nsAString & aStatusText, PRUint32 aWorkUnitsCompleted, PRUint32 aTotalWorkUnits) { return !_to ? NS_ERROR_NULL_POINTER : _to->OnProgressChanged(aActivity, aStatusText, aWorkUnitsCompleted, aTotalWorkUnits); } \
  NS_SCRIPTABLE NS_IMETHOD OnHandlerChanged(nsIActivity *aActivity) { return !_to ? NS_ERROR_NULL_POINTER : _to->OnHandlerChanged(aActivity); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsActivityListener : public nsIActivityListener
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIACTIVITYLISTENER

  nsActivityListener();

private:
  ~nsActivityListener();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsActivityListener, nsIActivityListener)

nsActivityListener::nsActivityListener()
{
  /* member initializers and constructor code */
}

nsActivityListener::~nsActivityListener()
{
  /* destructor code */
}

/* void onStateChanged (in nsIActivity aActivity, in short aOldState); */
NS_IMETHODIMP nsActivityListener::OnStateChanged(nsIActivity *aActivity, PRInt16 aOldState)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void onProgressChanged (in nsIActivity aActivity, in AString aStatusText, in unsigned long aWorkUnitsCompleted, in unsigned long aTotalWorkUnits); */
NS_IMETHODIMP nsActivityListener::OnProgressChanged(nsIActivity *aActivity, const nsAString & aStatusText, PRUint32 aWorkUnitsCompleted, PRUint32 aTotalWorkUnits)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void onHandlerChanged (in nsIActivity aActivity); */
NS_IMETHODIMP nsActivityListener::OnHandlerChanged(nsIActivity *aActivity)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIActivity_h__ */
