/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM /usr/src/packages/BUILD/thunderbird/mail/components/activity/nsIActivityManagerUI.idl
 */

#ifndef __gen_nsIActivityManagerUI_h__
#define __gen_nsIActivityManagerUI_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIInterfaceRequestor; /* forward declaration */


/* starting interface:    nsIActivityManagerUI */
#define NS_IACTIVITYMANAGERUI_IID_STR "ae7853b0-2e1f-4dc1-89cd-f8bbfb745d4d"

#define NS_IACTIVITYMANAGERUI_IID \
  {0xae7853b0, 0x2e1f, 0x4dc1, \
    { 0x89, 0xcd, 0xf8, 0xbb, 0xfb, 0x74, 0x5d, 0x4d }}

class NS_NO_VTABLE NS_SCRIPTABLE nsIActivityManagerUI : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IACTIVITYMANAGERUI_IID)

  /**
   * The reason that should be passed when the user requests to show the
   * activity manager's UI.
   */
  enum { REASON_USER_INTERACTED = 0 };

  /**
   * The reason that should be passed to the show method when we are displaying
   * the UI because a new activity is being added to it.
   */
  enum { REASON_NEW_ACTIVITY = 1 };

  /**
  * Shows the Activity Manager's UI to the user.
  *
  * @param [optional] aWindowContext
  *        The parent window context to show the UI.
  * @param [optional] aID
  *        The id of the activity to be preselected upon opening.
  * @param [optional] aReason
  *        The reason to show the activity manager's UI.  This defaults to
  *        REASON_USER_INTERACTED, and should be one of the previously listed
  *        constants.
  */
  /* void show ([optional] in nsIInterfaceRequestor aWindowContext, [optional] in unsigned long aID, [optional] in short aReason); */
  NS_SCRIPTABLE NS_IMETHOD Show(nsIInterfaceRequestor *aWindowContext, PRUint32 aID, PRInt16 aReason) = 0;

  /**
  * Indicates if the UI is visible or not.
  */
  /* readonly attribute boolean visible; */
  NS_SCRIPTABLE NS_IMETHOD GetVisible(PRBool *aVisible) = 0;

  /**
  * Brings attention to the UI if it is already visible
  *
  * @throws NS_ERROR_UNEXPECTED if the UI is not visible.
  */
  /* void getAttention (); */
  NS_SCRIPTABLE NS_IMETHOD GetAttention(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIActivityManagerUI, NS_IACTIVITYMANAGERUI_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIACTIVITYMANAGERUI \
  NS_SCRIPTABLE NS_IMETHOD Show(nsIInterfaceRequestor *aWindowContext, PRUint32 aID, PRInt16 aReason); \
  NS_SCRIPTABLE NS_IMETHOD GetVisible(PRBool *aVisible); \
  NS_SCRIPTABLE NS_IMETHOD GetAttention(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIACTIVITYMANAGERUI(_to) \
  NS_SCRIPTABLE NS_IMETHOD Show(nsIInterfaceRequestor *aWindowContext, PRUint32 aID, PRInt16 aReason) { return _to Show(aWindowContext, aID, aReason); } \
  NS_SCRIPTABLE NS_IMETHOD GetVisible(PRBool *aVisible) { return _to GetVisible(aVisible); } \
  NS_SCRIPTABLE NS_IMETHOD GetAttention(void) { return _to GetAttention(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIACTIVITYMANAGERUI(_to) \
  NS_SCRIPTABLE NS_IMETHOD Show(nsIInterfaceRequestor *aWindowContext, PRUint32 aID, PRInt16 aReason) { return !_to ? NS_ERROR_NULL_POINTER : _to->Show(aWindowContext, aID, aReason); } \
  NS_SCRIPTABLE NS_IMETHOD GetVisible(PRBool *aVisible) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetVisible(aVisible); } \
  NS_SCRIPTABLE NS_IMETHOD GetAttention(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAttention(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsActivityManagerUI : public nsIActivityManagerUI
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIACTIVITYMANAGERUI

  nsActivityManagerUI();

private:
  ~nsActivityManagerUI();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsActivityManagerUI, nsIActivityManagerUI)

nsActivityManagerUI::nsActivityManagerUI()
{
  /* member initializers and constructor code */
}

nsActivityManagerUI::~nsActivityManagerUI()
{
  /* destructor code */
}

/* void show ([optional] in nsIInterfaceRequestor aWindowContext, [optional] in unsigned long aID, [optional] in short aReason); */
NS_IMETHODIMP nsActivityManagerUI::Show(nsIInterfaceRequestor *aWindowContext, PRUint32 aID, PRInt16 aReason)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean visible; */
NS_IMETHODIMP nsActivityManagerUI::GetVisible(PRBool *aVisible)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getAttention (); */
NS_IMETHODIMP nsActivityManagerUI::GetAttention()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIActivityManagerUI_h__ */
