/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM /usr/src/packages/BUILD/thunderbird/mailnews/extensions/enigmail/public/nsIIPCService.idl
 */

#ifndef __gen_nsIIPCService_h__
#define __gen_nsIIPCService_h__


#ifndef __gen_nsIPipeTransport_h__
#include "nsIPipeTransport.h"
#endif

#ifndef __gen_nsIPipeConsole_h__
#include "nsIPipeConsole.h"
#endif

#ifndef __gen_nsIFile_h__
#include "nsIFile.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIURI; /* forward declaration */

class nsIChannel; /* forward declaration */

class nsIRequestObserver; /* forward declaration */

class nsIIPCRequest; /* forward declaration */

#define NS_IPCSERVICE_CLASSNAME  "IPCService"
#define NS_IPCSERVICE_CONTRACTID "@mozilla.org/process/ipc-service;1"
#define NS_IPCSERVICE_CID                        \
{ /* 8431e161-7ab1-11d4-8f02-006008948af5 */     \
   0x8431e161, 0x7ab1, 0x11d4,                   \
{0x8f, 0x02, 0x00, 0x60, 0x08, 0x94, 0x8a, 0xf5} }

/* starting interface:    nsIIPCService */
#define NS_IIPCSERVICE_IID_STR "8431e160-7ab1-11d4-8f02-006008948af5"

#define NS_IIPCSERVICE_IID \
  {0x8431e160, 0x7ab1, 0x11d4, \
    { 0x8f, 0x02, 0x00, 0x60, 0x08, 0x94, 0x8a, 0xf5 }}

/**
 * The nsIIPCService interface provides helper services for pipe-based
 * protocols.
 */
class NS_NO_VTABLE NS_SCRIPTABLE nsIIPCService : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IIPCSERVICE_IID)

  /**
   * Returns version of IPC Module
   */
  /* readonly attribute string version; */
  NS_SCRIPTABLE NS_IMETHOD GetVersion(char **aVersion) = 0;

  /**
   * Runs executable with parameters (args[]) and returns the standard output
   * emitted by the executable as a string. No shell expansion is carried out.
   * Unquoting (stripping quotes/backaslashes) is not done.
   * This method blocks for the completion of the executable.
   */
  /* string run (in nsIFile executable, [array, size_is (argCount)] in wstring args, in unsigned long argCount); */
  NS_SCRIPTABLE NS_IMETHOD Run(nsIFile *executable, const PRUnichar **args, PRUint32 argCount, char **_retval NS_OUTPARAM) = 0;

  /**
   * Runs executable with parameters (args[]) and optional data for standard input,
   * and returns the exit code from the process. The standard output
   * and standard error strings are returned as "out" arguments.
   * (If outputError is null, use default console to capture error output.)
   * PreInput may be used for passphrases etc.
   * Unquoting the command (stripping quotes/backaslashes) is not done.
   * This method blocks for the completion of the command.
   */
  /* long runPipe (in nsIFile executable, [array, size_is (argCount)] in wstring args, in unsigned long argCount, in string preInput, in string inputData, in unsigned long inputLength, [array, size_is (envCount)] in wstring env, in unsigned long envCount, [size_is (outputCount)] out string outputData, out unsigned long outputCount, [size_is (errorCount)] out string outputError, out unsigned long errorCount); */
  NS_SCRIPTABLE NS_IMETHOD RunPipe(nsIFile *executable, const PRUnichar **args, PRUint32 argCount, const char *preInput, const char *inputData, PRUint32 inputLength, const PRUnichar **env, PRUint32 envCount, char **outputData NS_OUTPARAM, PRUint32 *outputCount NS_OUTPARAM, char **outputError NS_OUTPARAM, PRUint32 *errorCount NS_OUTPARAM, PRInt32 *_retval NS_OUTPARAM) = 0;

  /**
   * Runs executable, with parameters (args[]) and optional data for standard input,
   * and asynchronously captures the standard output (and standard error
   * output) in supplied console(s). This method does not block for
   * command completion, unlike the other exec methods. The nsIIPCRequest
   * object associated with the command execution is returned, and may
   * be used to determine request status or cancel it.
   * If an nsIRequestObserver object is suppled, then it is used to
   * "observe" the standard output console, and the nsIIPCRequest object
   * is automatically supplied as the context argument to the observer.
   *
   * PreInput may be used for passphrases etc.
   * Unquoting the command (stripping quotes/backslashes) is not done.
   */
  /* nsIIPCRequest runAsync (in nsIFile executable, [array, size_is (argCount)] in wstring args, in unsigned long argCount, in string preInput, in string inputData, in unsigned long inputLength, [array, size_is (envCount)] in wstring env, in unsigned long envCount, in nsIPipeListener outConsole, in nsIPipeListener errConsole, in nsIRequestObserver requestObserver); */
  NS_SCRIPTABLE NS_IMETHOD RunAsync(nsIFile *executable, const PRUnichar **args, PRUint32 argCount, const char *preInput, const char *inputData, PRUint32 inputLength, const PRUnichar **env, PRUint32 envCount, nsIPipeListener *outConsole, nsIPipeListener *errConsole, nsIRequestObserver *requestObserver, nsIIPCRequest **_retval NS_OUTPARAM) = 0;

  /**
   * Returns console object used to capture STDERR by default
   */
  /* readonly attribute nsIPipeConsole console; */
  NS_SCRIPTABLE NS_IMETHOD GetConsole(nsIPipeConsole **aConsole) = 0;

  /**
   * Returns secret random cookie used for security
   */
  /* readonly attribute string cookie; */
  NS_SCRIPTABLE NS_IMETHOD GetCookie(char **aCookie) = 0;

  /**
   * Creates scriptable string channel from input string data.
   */
  /* nsIChannel newStringChannel (in nsIURI uri, in AUTF8String contentType, in AUTF8String contentCharset, in string channelData); */
  NS_SCRIPTABLE NS_IMETHOD NewStringChannel(nsIURI *uri, const nsACString & contentType, const nsACString & contentCharset, const char *channelData, nsIChannel **_retval NS_OUTPARAM) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIIPCService, NS_IIPCSERVICE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIIPCSERVICE \
  NS_SCRIPTABLE NS_IMETHOD GetVersion(char **aVersion); \
  NS_SCRIPTABLE NS_IMETHOD Run(nsIFile *executable, const PRUnichar **args, PRUint32 argCount, char **_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD RunPipe(nsIFile *executable, const PRUnichar **args, PRUint32 argCount, const char *preInput, const char *inputData, PRUint32 inputLength, const PRUnichar **env, PRUint32 envCount, char **outputData NS_OUTPARAM, PRUint32 *outputCount NS_OUTPARAM, char **outputError NS_OUTPARAM, PRUint32 *errorCount NS_OUTPARAM, PRInt32 *_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD RunAsync(nsIFile *executable, const PRUnichar **args, PRUint32 argCount, const char *preInput, const char *inputData, PRUint32 inputLength, const PRUnichar **env, PRUint32 envCount, nsIPipeListener *outConsole, nsIPipeListener *errConsole, nsIRequestObserver *requestObserver, nsIIPCRequest **_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD GetConsole(nsIPipeConsole **aConsole); \
  NS_SCRIPTABLE NS_IMETHOD GetCookie(char **aCookie); \
  NS_SCRIPTABLE NS_IMETHOD NewStringChannel(nsIURI *uri, const nsACString & contentType, const nsACString & contentCharset, const char *channelData, nsIChannel **_retval NS_OUTPARAM); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIIPCSERVICE(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetVersion(char **aVersion) { return _to GetVersion(aVersion); } \
  NS_SCRIPTABLE NS_IMETHOD Run(nsIFile *executable, const PRUnichar **args, PRUint32 argCount, char **_retval NS_OUTPARAM) { return _to Run(executable, args, argCount, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD RunPipe(nsIFile *executable, const PRUnichar **args, PRUint32 argCount, const char *preInput, const char *inputData, PRUint32 inputLength, const PRUnichar **env, PRUint32 envCount, char **outputData NS_OUTPARAM, PRUint32 *outputCount NS_OUTPARAM, char **outputError NS_OUTPARAM, PRUint32 *errorCount NS_OUTPARAM, PRInt32 *_retval NS_OUTPARAM) { return _to RunPipe(executable, args, argCount, preInput, inputData, inputLength, env, envCount, outputData, outputCount, outputError, errorCount, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD RunAsync(nsIFile *executable, const PRUnichar **args, PRUint32 argCount, const char *preInput, const char *inputData, PRUint32 inputLength, const PRUnichar **env, PRUint32 envCount, nsIPipeListener *outConsole, nsIPipeListener *errConsole, nsIRequestObserver *requestObserver, nsIIPCRequest **_retval NS_OUTPARAM) { return _to RunAsync(executable, args, argCount, preInput, inputData, inputLength, env, envCount, outConsole, errConsole, requestObserver, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetConsole(nsIPipeConsole **aConsole) { return _to GetConsole(aConsole); } \
  NS_SCRIPTABLE NS_IMETHOD GetCookie(char **aCookie) { return _to GetCookie(aCookie); } \
  NS_SCRIPTABLE NS_IMETHOD NewStringChannel(nsIURI *uri, const nsACString & contentType, const nsACString & contentCharset, const char *channelData, nsIChannel **_retval NS_OUTPARAM) { return _to NewStringChannel(uri, contentType, contentCharset, channelData, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIIPCSERVICE(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetVersion(char **aVersion) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetVersion(aVersion); } \
  NS_SCRIPTABLE NS_IMETHOD Run(nsIFile *executable, const PRUnichar **args, PRUint32 argCount, char **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->Run(executable, args, argCount, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD RunPipe(nsIFile *executable, const PRUnichar **args, PRUint32 argCount, const char *preInput, const char *inputData, PRUint32 inputLength, const PRUnichar **env, PRUint32 envCount, char **outputData NS_OUTPARAM, PRUint32 *outputCount NS_OUTPARAM, char **outputError NS_OUTPARAM, PRUint32 *errorCount NS_OUTPARAM, PRInt32 *_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->RunPipe(executable, args, argCount, preInput, inputData, inputLength, env, envCount, outputData, outputCount, outputError, errorCount, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD RunAsync(nsIFile *executable, const PRUnichar **args, PRUint32 argCount, const char *preInput, const char *inputData, PRUint32 inputLength, const PRUnichar **env, PRUint32 envCount, nsIPipeListener *outConsole, nsIPipeListener *errConsole, nsIRequestObserver *requestObserver, nsIIPCRequest **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->RunAsync(executable, args, argCount, preInput, inputData, inputLength, env, envCount, outConsole, errConsole, requestObserver, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetConsole(nsIPipeConsole **aConsole) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetConsole(aConsole); } \
  NS_SCRIPTABLE NS_IMETHOD GetCookie(char **aCookie) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCookie(aCookie); } \
  NS_SCRIPTABLE NS_IMETHOD NewStringChannel(nsIURI *uri, const nsACString & contentType, const nsACString & contentCharset, const char *channelData, nsIChannel **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->NewStringChannel(uri, contentType, contentCharset, channelData, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsIPCService : public nsIIPCService
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIIPCSERVICE

  nsIPCService();

private:
  ~nsIPCService();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsIPCService, nsIIPCService)

nsIPCService::nsIPCService()
{
  /* member initializers and constructor code */
}

nsIPCService::~nsIPCService()
{
  /* destructor code */
}

/* readonly attribute string version; */
NS_IMETHODIMP nsIPCService::GetVersion(char **aVersion)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* string run (in nsIFile executable, [array, size_is (argCount)] in wstring args, in unsigned long argCount); */
NS_IMETHODIMP nsIPCService::Run(nsIFile *executable, const PRUnichar **args, PRUint32 argCount, char **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* long runPipe (in nsIFile executable, [array, size_is (argCount)] in wstring args, in unsigned long argCount, in string preInput, in string inputData, in unsigned long inputLength, [array, size_is (envCount)] in wstring env, in unsigned long envCount, [size_is (outputCount)] out string outputData, out unsigned long outputCount, [size_is (errorCount)] out string outputError, out unsigned long errorCount); */
NS_IMETHODIMP nsIPCService::RunPipe(nsIFile *executable, const PRUnichar **args, PRUint32 argCount, const char *preInput, const char *inputData, PRUint32 inputLength, const PRUnichar **env, PRUint32 envCount, char **outputData NS_OUTPARAM, PRUint32 *outputCount NS_OUTPARAM, char **outputError NS_OUTPARAM, PRUint32 *errorCount NS_OUTPARAM, PRInt32 *_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIIPCRequest runAsync (in nsIFile executable, [array, size_is (argCount)] in wstring args, in unsigned long argCount, in string preInput, in string inputData, in unsigned long inputLength, [array, size_is (envCount)] in wstring env, in unsigned long envCount, in nsIPipeListener outConsole, in nsIPipeListener errConsole, in nsIRequestObserver requestObserver); */
NS_IMETHODIMP nsIPCService::RunAsync(nsIFile *executable, const PRUnichar **args, PRUint32 argCount, const char *preInput, const char *inputData, PRUint32 inputLength, const PRUnichar **env, PRUint32 envCount, nsIPipeListener *outConsole, nsIPipeListener *errConsole, nsIRequestObserver *requestObserver, nsIIPCRequest **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIPipeConsole console; */
NS_IMETHODIMP nsIPCService::GetConsole(nsIPipeConsole **aConsole)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute string cookie; */
NS_IMETHODIMP nsIPCService::GetCookie(char **aCookie)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIChannel newStringChannel (in nsIURI uri, in AUTF8String contentType, in AUTF8String contentCharset, in string channelData); */
NS_IMETHODIMP nsIPCService::NewStringChannel(nsIURI *uri, const nsACString & contentType, const nsACString & contentCharset, const char *channelData, nsIChannel **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIIPCRequest */
#define NS_IIPCREQUEST_IID_STR "8431e1a0-7ab1-11d4-8f02-006008948af5"

#define NS_IIPCREQUEST_IID \
  {0x8431e1a0, 0x7ab1, 0x11d4, \
    { 0x8f, 0x02, 0x00, 0x60, 0x08, 0x94, 0x8a, 0xf5 }}

class NS_NO_VTABLE NS_SCRIPTABLE nsIIPCRequest : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IIPCREQUEST_IID)

  /* void init (in string executable, in nsIPipeTransport pipeTransport, in nsIPipeListener stdoutConsole, in nsIPipeListener stderrConsole); */
  NS_SCRIPTABLE NS_IMETHOD Init(const char *executable, nsIPipeTransport *pipeTransport, nsIPipeListener *stdoutConsole, nsIPipeListener *stderrConsole) = 0;

  /**
   * Returns true if the request is still pending
   */
  /* boolean isPending (); */
  NS_SCRIPTABLE NS_IMETHOD IsPending(PRBool *_retval NS_OUTPARAM) = 0;

  /**
   * Terminates the pipeTransport associated with the request.
   * If CloseConsoles is true, the stdout/stderr consoles are also closed.
   */
  /* void close (in boolean closeConsoles); */
  NS_SCRIPTABLE NS_IMETHOD Close(PRBool closeConsoles) = 0;

  /* readonly attribute string executable; */
  NS_SCRIPTABLE NS_IMETHOD GetExecutable(char **aExecutable) = 0;

  /* readonly attribute nsIPipeTransport pipeTransport; */
  NS_SCRIPTABLE NS_IMETHOD GetPipeTransport(nsIPipeTransport **aPipeTransport) = 0;

  /* readonly attribute nsIPipeListener stdoutConsole; */
  NS_SCRIPTABLE NS_IMETHOD GetStdoutConsole(nsIPipeListener **aStdoutConsole) = 0;

  /* readonly attribute nsIPipeListener stderrConsole; */
  NS_SCRIPTABLE NS_IMETHOD GetStderrConsole(nsIPipeListener **aStderrConsole) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIIPCRequest, NS_IIPCREQUEST_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIIPCREQUEST \
  NS_SCRIPTABLE NS_IMETHOD Init(const char *executable, nsIPipeTransport *pipeTransport, nsIPipeListener *stdoutConsole, nsIPipeListener *stderrConsole); \
  NS_SCRIPTABLE NS_IMETHOD IsPending(PRBool *_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD Close(PRBool closeConsoles); \
  NS_SCRIPTABLE NS_IMETHOD GetExecutable(char **aExecutable); \
  NS_SCRIPTABLE NS_IMETHOD GetPipeTransport(nsIPipeTransport **aPipeTransport); \
  NS_SCRIPTABLE NS_IMETHOD GetStdoutConsole(nsIPipeListener **aStdoutConsole); \
  NS_SCRIPTABLE NS_IMETHOD GetStderrConsole(nsIPipeListener **aStderrConsole); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIIPCREQUEST(_to) \
  NS_SCRIPTABLE NS_IMETHOD Init(const char *executable, nsIPipeTransport *pipeTransport, nsIPipeListener *stdoutConsole, nsIPipeListener *stderrConsole) { return _to Init(executable, pipeTransport, stdoutConsole, stderrConsole); } \
  NS_SCRIPTABLE NS_IMETHOD IsPending(PRBool *_retval NS_OUTPARAM) { return _to IsPending(_retval); } \
  NS_SCRIPTABLE NS_IMETHOD Close(PRBool closeConsoles) { return _to Close(closeConsoles); } \
  NS_SCRIPTABLE NS_IMETHOD GetExecutable(char **aExecutable) { return _to GetExecutable(aExecutable); } \
  NS_SCRIPTABLE NS_IMETHOD GetPipeTransport(nsIPipeTransport **aPipeTransport) { return _to GetPipeTransport(aPipeTransport); } \
  NS_SCRIPTABLE NS_IMETHOD GetStdoutConsole(nsIPipeListener **aStdoutConsole) { return _to GetStdoutConsole(aStdoutConsole); } \
  NS_SCRIPTABLE NS_IMETHOD GetStderrConsole(nsIPipeListener **aStderrConsole) { return _to GetStderrConsole(aStderrConsole); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIIPCREQUEST(_to) \
  NS_SCRIPTABLE NS_IMETHOD Init(const char *executable, nsIPipeTransport *pipeTransport, nsIPipeListener *stdoutConsole, nsIPipeListener *stderrConsole) { return !_to ? NS_ERROR_NULL_POINTER : _to->Init(executable, pipeTransport, stdoutConsole, stderrConsole); } \
  NS_SCRIPTABLE NS_IMETHOD IsPending(PRBool *_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsPending(_retval); } \
  NS_SCRIPTABLE NS_IMETHOD Close(PRBool closeConsoles) { return !_to ? NS_ERROR_NULL_POINTER : _to->Close(closeConsoles); } \
  NS_SCRIPTABLE NS_IMETHOD GetExecutable(char **aExecutable) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetExecutable(aExecutable); } \
  NS_SCRIPTABLE NS_IMETHOD GetPipeTransport(nsIPipeTransport **aPipeTransport) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPipeTransport(aPipeTransport); } \
  NS_SCRIPTABLE NS_IMETHOD GetStdoutConsole(nsIPipeListener **aStdoutConsole) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStdoutConsole(aStdoutConsole); } \
  NS_SCRIPTABLE NS_IMETHOD GetStderrConsole(nsIPipeListener **aStderrConsole) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStderrConsole(aStderrConsole); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsIPCRequest : public nsIIPCRequest
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIIPCREQUEST

  nsIPCRequest();

private:
  ~nsIPCRequest();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsIPCRequest, nsIIPCRequest)

nsIPCRequest::nsIPCRequest()
{
  /* member initializers and constructor code */
}

nsIPCRequest::~nsIPCRequest()
{
  /* destructor code */
}

/* void init (in string executable, in nsIPipeTransport pipeTransport, in nsIPipeListener stdoutConsole, in nsIPipeListener stderrConsole); */
NS_IMETHODIMP nsIPCRequest::Init(const char *executable, nsIPipeTransport *pipeTransport, nsIPipeListener *stdoutConsole, nsIPipeListener *stderrConsole)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isPending (); */
NS_IMETHODIMP nsIPCRequest::IsPending(PRBool *_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void close (in boolean closeConsoles); */
NS_IMETHODIMP nsIPCRequest::Close(PRBool closeConsoles)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute string executable; */
NS_IMETHODIMP nsIPCRequest::GetExecutable(char **aExecutable)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIPipeTransport pipeTransport; */
NS_IMETHODIMP nsIPCRequest::GetPipeTransport(nsIPipeTransport **aPipeTransport)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIPipeListener stdoutConsole; */
NS_IMETHODIMP nsIPCRequest::GetStdoutConsole(nsIPipeListener **aStdoutConsole)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIPipeListener stderrConsole; */
NS_IMETHODIMP nsIPCRequest::GetStderrConsole(nsIPipeListener **aStderrConsole)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIIPCService_h__ */
