/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM /usr/src/packages/BUILD/thunderbird/mailnews/extensions/enigmail/ipc/public/nsIPipeListener.idl
 */

#ifndef __gen_nsIPipeListener_h__
#define __gen_nsIPipeListener_h__


#ifndef __gen_nsIStreamListener_h__
#include "nsIStreamListener.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
#include "IPCProcess.h"
#define NS_PIPELISTENER_CLASSNAME "IPC PipeListener"
#define NS_PIPELISTENER_CONTRACTID "@mozilla.org/ipc/pipe-listener;1"

/* starting interface:    nsIPipeListener */
#define NS_IPIPELISTENER_IID_STR "8431e1d0-7ab1-11d4-8f02-a06008948af5"

#define NS_IPIPELISTENER_IID \
  {0x8431e1d0, 0x7ab1, 0x11d4, \
    { 0x8f, 0x02, 0xa0, 0x60, 0x08, 0x94, 0x8a, 0xf5 }}

class NS_NO_VTABLE NS_SCRIPTABLE nsIPipeListener : public nsIStreamListener {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IPIPELISTENER_IID)

  /**
   * Observes any asynchronous request associated with console.
   * (E.g., when console is used to capture stdout from
   *  nsIPipeTransport.execAsync)
   *
   * @param observer  The nsIRequestObserver object
   * @param ctxt      A user-defined context value that is passed to the
   *                  observer.
   */
  /* void observe (in nsIRequestObserver observer, in nsISupports ctxt); */
  NS_SCRIPTABLE NS_IMETHOD Observe(nsIRequestObserver *observer, nsISupports *ctxt) = 0;

  /**
   * true if console pipe thread may be terminated
   */
  /* readonly attribute boolean joinable; */
  NS_SCRIPTABLE NS_IMETHOD GetJoinable(PRBool *aJoinable) = 0;

  /**
   * Close input pipe and blocks for console logging thread to terminate,
   * ensuring that all data already written to the console pipe is available
   * for reading from console buffer.
   */
  /* void join (); */
  NS_SCRIPTABLE NS_IMETHOD Join(void) = 0;

  /**
   * Shuts down listener (without blocking).
   * Any data already written to the input pipe is discarded.
   */
  /* void shutdown (); */
  NS_SCRIPTABLE NS_IMETHOD Shutdown(void) = 0;

  /**
   * Accesses buffer data as a string of arbitrary bytes,
   * including NUL characters.
   */
  /* void getByteData (out unsigned long count, [retval, size_is (count)] out string data); */
  NS_SCRIPTABLE NS_IMETHOD GetByteData(PRUint32 *count NS_OUTPARAM, char **data NS_OUTPARAM) = 0;

  /**
   * True if data has been lost (i.e., getByteData does not return all data)
   */
  /* readonly attribute boolean overflowed; */
  NS_SCRIPTABLE NS_IMETHOD GetOverflowed(PRBool *aOverflowed) = 0;

  /**
   * Writes a string into the buffer
   */
  /* void write (in string str); */
  NS_SCRIPTABLE NS_IMETHOD Write(const char *str) = 0;

  /**
   * Writes data into the buffer. Data is a string of arbitrary bytes including
   * NUL characters.
   */
  /* [noscript] void writeBuf (in string buf, in unsigned long count); */
  NS_IMETHOD WriteBuf(const char *buf, PRUint32 count) = 0;

  /**
   * Returns pipe file descriptor associated with listener.
   */
  /* [noscript] IPCFileDescStar GetFileDesc (); */
  NS_IMETHOD GetFileDesc(IPCFileDesc **_retval NS_OUTPARAM) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIPipeListener, NS_IPIPELISTENER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPIPELISTENER \
  NS_SCRIPTABLE NS_IMETHOD Observe(nsIRequestObserver *observer, nsISupports *ctxt); \
  NS_SCRIPTABLE NS_IMETHOD GetJoinable(PRBool *aJoinable); \
  NS_SCRIPTABLE NS_IMETHOD Join(void); \
  NS_SCRIPTABLE NS_IMETHOD Shutdown(void); \
  NS_SCRIPTABLE NS_IMETHOD GetByteData(PRUint32 *count NS_OUTPARAM, char **data NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD GetOverflowed(PRBool *aOverflowed); \
  NS_SCRIPTABLE NS_IMETHOD Write(const char *str); \
  NS_IMETHOD WriteBuf(const char *buf, PRUint32 count); \
  NS_IMETHOD GetFileDesc(IPCFileDesc **_retval NS_OUTPARAM); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPIPELISTENER(_to) \
  NS_SCRIPTABLE NS_IMETHOD Observe(nsIRequestObserver *observer, nsISupports *ctxt) { return _to Observe(observer, ctxt); } \
  NS_SCRIPTABLE NS_IMETHOD GetJoinable(PRBool *aJoinable) { return _to GetJoinable(aJoinable); } \
  NS_SCRIPTABLE NS_IMETHOD Join(void) { return _to Join(); } \
  NS_SCRIPTABLE NS_IMETHOD Shutdown(void) { return _to Shutdown(); } \
  NS_SCRIPTABLE NS_IMETHOD GetByteData(PRUint32 *count NS_OUTPARAM, char **data NS_OUTPARAM) { return _to GetByteData(count, data); } \
  NS_SCRIPTABLE NS_IMETHOD GetOverflowed(PRBool *aOverflowed) { return _to GetOverflowed(aOverflowed); } \
  NS_SCRIPTABLE NS_IMETHOD Write(const char *str) { return _to Write(str); } \
  NS_IMETHOD WriteBuf(const char *buf, PRUint32 count) { return _to WriteBuf(buf, count); } \
  NS_IMETHOD GetFileDesc(IPCFileDesc **_retval NS_OUTPARAM) { return _to GetFileDesc(_retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPIPELISTENER(_to) \
  NS_SCRIPTABLE NS_IMETHOD Observe(nsIRequestObserver *observer, nsISupports *ctxt) { return !_to ? NS_ERROR_NULL_POINTER : _to->Observe(observer, ctxt); } \
  NS_SCRIPTABLE NS_IMETHOD GetJoinable(PRBool *aJoinable) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetJoinable(aJoinable); } \
  NS_SCRIPTABLE NS_IMETHOD Join(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Join(); } \
  NS_SCRIPTABLE NS_IMETHOD Shutdown(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Shutdown(); } \
  NS_SCRIPTABLE NS_IMETHOD GetByteData(PRUint32 *count NS_OUTPARAM, char **data NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetByteData(count, data); } \
  NS_SCRIPTABLE NS_IMETHOD GetOverflowed(PRBool *aOverflowed) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOverflowed(aOverflowed); } \
  NS_SCRIPTABLE NS_IMETHOD Write(const char *str) { return !_to ? NS_ERROR_NULL_POINTER : _to->Write(str); } \
  NS_IMETHOD WriteBuf(const char *buf, PRUint32 count) { return !_to ? NS_ERROR_NULL_POINTER : _to->WriteBuf(buf, count); } \
  NS_IMETHOD GetFileDesc(IPCFileDesc **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFileDesc(_retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPipeListener : public nsIPipeListener
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPIPELISTENER

  nsPipeListener();

private:
  ~nsPipeListener();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPipeListener, nsIPipeListener)

nsPipeListener::nsPipeListener()
{
  /* member initializers and constructor code */
}

nsPipeListener::~nsPipeListener()
{
  /* destructor code */
}

/* void observe (in nsIRequestObserver observer, in nsISupports ctxt); */
NS_IMETHODIMP nsPipeListener::Observe(nsIRequestObserver *observer, nsISupports *ctxt)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean joinable; */
NS_IMETHODIMP nsPipeListener::GetJoinable(PRBool *aJoinable)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void join (); */
NS_IMETHODIMP nsPipeListener::Join()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void shutdown (); */
NS_IMETHODIMP nsPipeListener::Shutdown()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getByteData (out unsigned long count, [retval, size_is (count)] out string data); */
NS_IMETHODIMP nsPipeListener::GetByteData(PRUint32 *count NS_OUTPARAM, char **data NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean overflowed; */
NS_IMETHODIMP nsPipeListener::GetOverflowed(PRBool *aOverflowed)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void write (in string str); */
NS_IMETHODIMP nsPipeListener::Write(const char *str)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] void writeBuf (in string buf, in unsigned long count); */
NS_IMETHODIMP nsPipeListener::WriteBuf(const char *buf, PRUint32 count)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] IPCFileDescStar GetFileDesc (); */
NS_IMETHODIMP nsPipeListener::GetFileDesc(IPCFileDesc **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIPipeListener_h__ */
