/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM /usr/src/packages/BUILD/thunderbird/mailnews/extensions/enigmail/ipc/public/nsIPipeTransport.idl
 */

#ifndef __gen_nsIPipeTransport_h__
#define __gen_nsIPipeTransport_h__


#ifndef __gen_nsIPipeListener_h__
#include "nsIPipeListener.h"
#endif

#ifndef __gen_nsIProcess_h__
#include "nsIProcess.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIRequest; /* forward declaration */

class nsIFile; /* forward declaration */

class nsIInputStream; /* forward declaration */

class nsIOutputStream; /* forward declaration */

class nsIStreamListener; /* forward declaration */

class nsIPipeTransportHeaders; /* forward declaration */

class nsIPipeTransportListener; /* forward declaration */

class nsIProcess; /* forward declaration */

#include "IPCProcess.h"
#define NS_PIPETRANSPORT_CLASSNAME "Pipe Transport"
#define NS_PIPETRANSPORT_CONTRACTID "@mozilla.org/ipc/pipe-transport;1"
#define NS_PIPETRANSPORT_CID                     \
{ /* 8431e101-7ab1-11d4-8f02-a06008948af5 */     \
   0x8431e101, 0x7ab1, 0x11d4,                   \
{0x8f, 0x02, 0xa0, 0x60, 0x08, 0x94, 0x8a, 0xf5} }

/* starting interface:    nsIPipeTransport */
#define NS_IPIPETRANSPORT_IID_STR "8431e100-7ab1-11d4-8f02-a06008948af5"

#define NS_IPIPETRANSPORT_IID \
  {0x8431e100, 0x7ab1, 0x11d4, \
    { 0x8f, 0x02, 0xa0, 0x60, 0x08, 0x94, 0x8a, 0xf5 }}

/**
 * The nsIPipeTransport interface executes a file in a new process and
 * communicates with the process using pipes.
 *
 * OWNERSHIP AND THREADING MODEL for nsPipeTransport:
 *
 * nsPipeTransport can be created in any thread with an event queue.
 *
 * nsPipeTransport lives only in the thread that it was created in.
 *
 * nsPipeTransport creates a helper thread object, nsStdoutPoller and retains
 * an owning reference to it. nsStdoutPoller also holds a strong reference
 * to a proxy interface (nsIPipeTransportListener) implemented by
 * nsPipeTransport, which is released when the polling thread terminates.
 *
 * The polling thread terminates when it is "interrupted" by nsPipeTransport or
 * when EOF/error is encountered in reading data from the process STDOUT.
 *
 * The "terminate" method should *always* be called to release the process
 * resources when done.
 *
 * For asynchronous reading, when nsStdoutPoller terminates of its own accord,
 * any stream listener is informed by invoking OnStopRequest.
 * Usually this listener will be the same as the owner of nsPipeTransport.
 * (If the owner initiates the request shutdown by first calling "cancel",
 *  then the OnStopRequest method is *not* invoked, because it is assumed
 *  that the listener/owner is already aware of the shutdown.)
 *
 */
class NS_NO_VTABLE NS_SCRIPTABLE nsIPipeTransport : public nsIProcess {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IPIPETRANSPORT_IID)

  /**
     * Initializes PipeTransport by executing the specified file using the
     * supplied argument list and environment variables.
     * It is expected that nsIPipeTransport will be embedded in a
     * full-featured channel, which will also act as an async stream
     * observer/listener and forward calls to the actual observer/listener.
     *
     * @param executable   executable file
     * @param cwd          working directory for the excutable
     * @param startupFlags flags defining how the process should be created
     */
  /* void initWithWorkDir (in nsIFile executable, in nsIFile cwd, in unsigned long startupFlags); */
  NS_SCRIPTABLE NS_IMETHOD InitWithWorkDir(nsIFile *executable, nsIFile *cwd, PRUint32 startupFlags) = 0;

  /**
     * Opens a PipeTransport by executing the specified file using the
     * supplied argument list and environment variables.
     * It is expected that nsIPipeTransport will be embedded in a
     * full-featured channel, which will also act as an async stream
     * observer/listener and forward calls to the actual observer/listener.
     *
     * @param args          arguments string array
     *                      (excluding the executable path itself)
     * @param env           environment (variable=value) string array
     * @param timeoutMS     timeout (in milliseconds) after which the process
     *                      at the other end of the pipe can be assumed to be
     *                      dead
     *                      (if == 0, a default value, usually an hour, is used)
     * @param killString    string to be transmitted to process before it is
     *                      killed (specify null string, if none)
     * @param mergeStderr   merge STDERR with STDOUT
     * @param stderrConsole nsIPipeListener object to capture STDERR (required
     *                      if mergeStderr is false)
     */
  /* void openPipe ([array, size_is (argCount)] in wstring args, in unsigned long argCount, [array, size_is (envCount)] in wstring env, in unsigned long envCount, in unsigned long timeoutMS, in string killString, in boolean mergeStderr, in nsIPipeListener stderrConsole); */
  NS_SCRIPTABLE NS_IMETHOD OpenPipe(const PRUnichar **args, PRUint32 argCount, const PRUnichar **env, PRUint32 envCount, PRUint32 timeoutMS, const char *killString, PRBool mergeStderr, nsIPipeListener *stderrConsole) = 0;

  /**
     * detach process after start
     */
  enum { PROCESS_DETACHED = 1 };

  enum { INHERIT_PROC_ATTRIBS = 2 };

  /**
     * Returns stderrConsole object used to capture STDERR by default
     */
  /* readonly attribute nsIPipeListener stderrConsole; */
  NS_SCRIPTABLE NS_IMETHOD GetStderrConsole(nsIPipeListener **aStderrConsole) = 0;

  /**
     * Returns listener object to feed data to STDIN
     * (call to OnStopRequest closes STDIN)
     */
  /* readonly attribute nsIStreamListener listener; */
  NS_SCRIPTABLE NS_IMETHOD GetListener(nsIStreamListener **aListener) = 0;

  /**
     * Specifies interface to handle MIME headers read from STDOUT
     */
  /* attribute nsIPipeTransportHeaders headerProcessor; */
  NS_SCRIPTABLE NS_IMETHOD GetHeaderProcessor(nsIPipeTransportHeaders **aHeaderProcessor) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetHeaderProcessor(nsIPipeTransportHeaders *aHeaderProcessor) = 0;

  /**
     * Controls console logging of STDOUT from process
     */
  /* attribute boolean loggingEnabled; */
  NS_SCRIPTABLE NS_IMETHOD GetLoggingEnabled(PRBool *aLoggingEnabled) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetLoggingEnabled(PRBool aLoggingEnabled) = 0;

  /**
     * Open an input stream on this transport.
     *
     * @param offset - read starting at this offset
     * @param count  - read this many bytes (pass PRUint32(-1) if unlimited)
     * @param flags  - optional transport specific flags
     */
  /* nsIInputStream openInputStream (in unsigned long offset, in unsigned long count, in unsigned long flags); */
  NS_SCRIPTABLE NS_IMETHOD OpenInputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIInputStream **_retval NS_OUTPARAM) = 0;

  /**
     * Open an output stream on this transport.
     *
     * @param offset - write starting at this offset
     * @param count  - write no more than this many bytes (pass PRUint32(-1) if
     *                 unlimited)
     * @param flags  - optional transport specific flags
     */
  /* nsIOutputStream openOutputStream (in unsigned long offset, in unsigned long count, in unsigned long flags); */
  NS_SCRIPTABLE NS_IMETHOD OpenOutputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIOutputStream **_retval NS_OUTPARAM) = 0;

  /**
     * Asynchronously read data from the transport.
     *
     * @param listener - notify this listener when data is available
     * @param ctxt     - opaque parameter passed to listener methods
     * @param offset   - read starting at this offset
     * @param count    - read this many bytes (pass PRUint32(-1) if unlimited)
     * @param flags    - optional transport specific flags
     */
  /* nsIRequest asyncRead (in nsIStreamListener listener, in nsISupports ctxt, in unsigned long offset, in unsigned long count, in unsigned long flags); */
  NS_SCRIPTABLE NS_IMETHOD AsyncRead(nsIStreamListener *listener, nsISupports *ctxt, PRUint32 offset, PRUint32 count, PRUint32 flags, nsIRequest **_retval NS_OUTPARAM) = 0;

  /**
     * Joins STDOUT handling thread (blocking until STDOUT is closed),
     * the process still needs to be terminated to free resources.
     */
  /* void join (); */
  NS_SCRIPTABLE NS_IMETHOD Join(void) = 0;

  /**
     * Terminates process, if active, by closing stdin/stdout/stderr.
     */
  /* void terminate (); */
  NS_SCRIPTABLE NS_IMETHOD Terminate(void) = 0;

  /**
     * Writes string to process STDIN (synchronously)
     * (Note: child process may exit for valid reasons even before
     *  the first call to writeSync, causing an an exception to be
     *  thrown because STDIN has been closed by the child.)
     */
  /* void writeSync (in string inputData, in unsigned long inputLength); */
  NS_SCRIPTABLE NS_IMETHOD WriteSync(const char *inputData, PRUint32 inputLength) = 0;

  /**
     * closes process STDIN (required even if no data is being transmitted)
     */
  /* void closeStdin (); */
  NS_SCRIPTABLE NS_IMETHOD CloseStdin(void) = 0;

  /**
     * Writes stream data to process STDIN (asynchronously),
     * and close inputStream and STDIN after writing, if requested
     */
  /* void writeAsync (in nsIInputStream aFromStream, in unsigned long aCount, in boolean closeAfterWrite); */
  NS_SCRIPTABLE NS_IMETHOD WriteAsync(nsIInputStream *aFromStream, PRUint32 aCount, PRBool closeAfterWrite) = 0;

  /**
     * Blocks for output and returns the first line from STDOUT
     * as a string, up to maxChars (=-1 for unlimited) long.
     * NOTE: This method is intended for short output; for longer
     * output, reading using a stream is the better method.
     */
  /* string readLine (in long maxOutputLen); */
  NS_SCRIPTABLE NS_IMETHOD ReadLine(PRInt32 maxOutputLen, char **_retval NS_OUTPARAM) = 0;

  /* attribute unsigned long bufferSegmentSize; */
  NS_SCRIPTABLE NS_IMETHOD GetBufferSegmentSize(PRUint32 *aBufferSegmentSize) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetBufferSegmentSize(PRUint32 aBufferSegmentSize) = 0;

  /* attribute unsigned long bufferMaxSize; */
  NS_SCRIPTABLE NS_IMETHOD GetBufferMaxSize(PRUint32 *aBufferMaxSize) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetBufferMaxSize(PRUint32 aBufferMaxSize) = 0;

  /* attribute unsigned long headersMaxSize; */
  NS_SCRIPTABLE NS_IMETHOD GetHeadersMaxSize(PRUint32 *aHeadersMaxSize) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetHeadersMaxSize(PRUint32 aHeadersMaxSize) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIPipeTransport, NS_IPIPETRANSPORT_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPIPETRANSPORT \
  NS_SCRIPTABLE NS_IMETHOD InitWithWorkDir(nsIFile *executable, nsIFile *cwd, PRUint32 startupFlags); \
  NS_SCRIPTABLE NS_IMETHOD OpenPipe(const PRUnichar **args, PRUint32 argCount, const PRUnichar **env, PRUint32 envCount, PRUint32 timeoutMS, const char *killString, PRBool mergeStderr, nsIPipeListener *stderrConsole); \
  NS_SCRIPTABLE NS_IMETHOD GetStderrConsole(nsIPipeListener **aStderrConsole); \
  NS_SCRIPTABLE NS_IMETHOD GetListener(nsIStreamListener **aListener); \
  NS_SCRIPTABLE NS_IMETHOD GetHeaderProcessor(nsIPipeTransportHeaders **aHeaderProcessor); \
  NS_SCRIPTABLE NS_IMETHOD SetHeaderProcessor(nsIPipeTransportHeaders *aHeaderProcessor); \
  NS_SCRIPTABLE NS_IMETHOD GetLoggingEnabled(PRBool *aLoggingEnabled); \
  NS_SCRIPTABLE NS_IMETHOD SetLoggingEnabled(PRBool aLoggingEnabled); \
  NS_SCRIPTABLE NS_IMETHOD OpenInputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIInputStream **_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD OpenOutputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIOutputStream **_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD AsyncRead(nsIStreamListener *listener, nsISupports *ctxt, PRUint32 offset, PRUint32 count, PRUint32 flags, nsIRequest **_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD Join(void); \
  NS_SCRIPTABLE NS_IMETHOD Terminate(void); \
  NS_SCRIPTABLE NS_IMETHOD WriteSync(const char *inputData, PRUint32 inputLength); \
  NS_SCRIPTABLE NS_IMETHOD CloseStdin(void); \
  NS_SCRIPTABLE NS_IMETHOD WriteAsync(nsIInputStream *aFromStream, PRUint32 aCount, PRBool closeAfterWrite); \
  NS_SCRIPTABLE NS_IMETHOD ReadLine(PRInt32 maxOutputLen, char **_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD GetBufferSegmentSize(PRUint32 *aBufferSegmentSize); \
  NS_SCRIPTABLE NS_IMETHOD SetBufferSegmentSize(PRUint32 aBufferSegmentSize); \
  NS_SCRIPTABLE NS_IMETHOD GetBufferMaxSize(PRUint32 *aBufferMaxSize); \
  NS_SCRIPTABLE NS_IMETHOD SetBufferMaxSize(PRUint32 aBufferMaxSize); \
  NS_SCRIPTABLE NS_IMETHOD GetHeadersMaxSize(PRUint32 *aHeadersMaxSize); \
  NS_SCRIPTABLE NS_IMETHOD SetHeadersMaxSize(PRUint32 aHeadersMaxSize); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPIPETRANSPORT(_to) \
  NS_SCRIPTABLE NS_IMETHOD InitWithWorkDir(nsIFile *executable, nsIFile *cwd, PRUint32 startupFlags) { return _to InitWithWorkDir(executable, cwd, startupFlags); } \
  NS_SCRIPTABLE NS_IMETHOD OpenPipe(const PRUnichar **args, PRUint32 argCount, const PRUnichar **env, PRUint32 envCount, PRUint32 timeoutMS, const char *killString, PRBool mergeStderr, nsIPipeListener *stderrConsole) { return _to OpenPipe(args, argCount, env, envCount, timeoutMS, killString, mergeStderr, stderrConsole); } \
  NS_SCRIPTABLE NS_IMETHOD GetStderrConsole(nsIPipeListener **aStderrConsole) { return _to GetStderrConsole(aStderrConsole); } \
  NS_SCRIPTABLE NS_IMETHOD GetListener(nsIStreamListener **aListener) { return _to GetListener(aListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetHeaderProcessor(nsIPipeTransportHeaders **aHeaderProcessor) { return _to GetHeaderProcessor(aHeaderProcessor); } \
  NS_SCRIPTABLE NS_IMETHOD SetHeaderProcessor(nsIPipeTransportHeaders *aHeaderProcessor) { return _to SetHeaderProcessor(aHeaderProcessor); } \
  NS_SCRIPTABLE NS_IMETHOD GetLoggingEnabled(PRBool *aLoggingEnabled) { return _to GetLoggingEnabled(aLoggingEnabled); } \
  NS_SCRIPTABLE NS_IMETHOD SetLoggingEnabled(PRBool aLoggingEnabled) { return _to SetLoggingEnabled(aLoggingEnabled); } \
  NS_SCRIPTABLE NS_IMETHOD OpenInputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIInputStream **_retval NS_OUTPARAM) { return _to OpenInputStream(offset, count, flags, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD OpenOutputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIOutputStream **_retval NS_OUTPARAM) { return _to OpenOutputStream(offset, count, flags, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD AsyncRead(nsIStreamListener *listener, nsISupports *ctxt, PRUint32 offset, PRUint32 count, PRUint32 flags, nsIRequest **_retval NS_OUTPARAM) { return _to AsyncRead(listener, ctxt, offset, count, flags, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD Join(void) { return _to Join(); } \
  NS_SCRIPTABLE NS_IMETHOD Terminate(void) { return _to Terminate(); } \
  NS_SCRIPTABLE NS_IMETHOD WriteSync(const char *inputData, PRUint32 inputLength) { return _to WriteSync(inputData, inputLength); } \
  NS_SCRIPTABLE NS_IMETHOD CloseStdin(void) { return _to CloseStdin(); } \
  NS_SCRIPTABLE NS_IMETHOD WriteAsync(nsIInputStream *aFromStream, PRUint32 aCount, PRBool closeAfterWrite) { return _to WriteAsync(aFromStream, aCount, closeAfterWrite); } \
  NS_SCRIPTABLE NS_IMETHOD ReadLine(PRInt32 maxOutputLen, char **_retval NS_OUTPARAM) { return _to ReadLine(maxOutputLen, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetBufferSegmentSize(PRUint32 *aBufferSegmentSize) { return _to GetBufferSegmentSize(aBufferSegmentSize); } \
  NS_SCRIPTABLE NS_IMETHOD SetBufferSegmentSize(PRUint32 aBufferSegmentSize) { return _to SetBufferSegmentSize(aBufferSegmentSize); } \
  NS_SCRIPTABLE NS_IMETHOD GetBufferMaxSize(PRUint32 *aBufferMaxSize) { return _to GetBufferMaxSize(aBufferMaxSize); } \
  NS_SCRIPTABLE NS_IMETHOD SetBufferMaxSize(PRUint32 aBufferMaxSize) { return _to SetBufferMaxSize(aBufferMaxSize); } \
  NS_SCRIPTABLE NS_IMETHOD GetHeadersMaxSize(PRUint32 *aHeadersMaxSize) { return _to GetHeadersMaxSize(aHeadersMaxSize); } \
  NS_SCRIPTABLE NS_IMETHOD SetHeadersMaxSize(PRUint32 aHeadersMaxSize) { return _to SetHeadersMaxSize(aHeadersMaxSize); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPIPETRANSPORT(_to) \
  NS_SCRIPTABLE NS_IMETHOD InitWithWorkDir(nsIFile *executable, nsIFile *cwd, PRUint32 startupFlags) { return !_to ? NS_ERROR_NULL_POINTER : _to->InitWithWorkDir(executable, cwd, startupFlags); } \
  NS_SCRIPTABLE NS_IMETHOD OpenPipe(const PRUnichar **args, PRUint32 argCount, const PRUnichar **env, PRUint32 envCount, PRUint32 timeoutMS, const char *killString, PRBool mergeStderr, nsIPipeListener *stderrConsole) { return !_to ? NS_ERROR_NULL_POINTER : _to->OpenPipe(args, argCount, env, envCount, timeoutMS, killString, mergeStderr, stderrConsole); } \
  NS_SCRIPTABLE NS_IMETHOD GetStderrConsole(nsIPipeListener **aStderrConsole) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStderrConsole(aStderrConsole); } \
  NS_SCRIPTABLE NS_IMETHOD GetListener(nsIStreamListener **aListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetListener(aListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetHeaderProcessor(nsIPipeTransportHeaders **aHeaderProcessor) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetHeaderProcessor(aHeaderProcessor); } \
  NS_SCRIPTABLE NS_IMETHOD SetHeaderProcessor(nsIPipeTransportHeaders *aHeaderProcessor) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetHeaderProcessor(aHeaderProcessor); } \
  NS_SCRIPTABLE NS_IMETHOD GetLoggingEnabled(PRBool *aLoggingEnabled) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLoggingEnabled(aLoggingEnabled); } \
  NS_SCRIPTABLE NS_IMETHOD SetLoggingEnabled(PRBool aLoggingEnabled) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetLoggingEnabled(aLoggingEnabled); } \
  NS_SCRIPTABLE NS_IMETHOD OpenInputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIInputStream **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->OpenInputStream(offset, count, flags, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD OpenOutputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIOutputStream **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->OpenOutputStream(offset, count, flags, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD AsyncRead(nsIStreamListener *listener, nsISupports *ctxt, PRUint32 offset, PRUint32 count, PRUint32 flags, nsIRequest **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->AsyncRead(listener, ctxt, offset, count, flags, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD Join(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Join(); } \
  NS_SCRIPTABLE NS_IMETHOD Terminate(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Terminate(); } \
  NS_SCRIPTABLE NS_IMETHOD WriteSync(const char *inputData, PRUint32 inputLength) { return !_to ? NS_ERROR_NULL_POINTER : _to->WriteSync(inputData, inputLength); } \
  NS_SCRIPTABLE NS_IMETHOD CloseStdin(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->CloseStdin(); } \
  NS_SCRIPTABLE NS_IMETHOD WriteAsync(nsIInputStream *aFromStream, PRUint32 aCount, PRBool closeAfterWrite) { return !_to ? NS_ERROR_NULL_POINTER : _to->WriteAsync(aFromStream, aCount, closeAfterWrite); } \
  NS_SCRIPTABLE NS_IMETHOD ReadLine(PRInt32 maxOutputLen, char **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->ReadLine(maxOutputLen, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetBufferSegmentSize(PRUint32 *aBufferSegmentSize) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBufferSegmentSize(aBufferSegmentSize); } \
  NS_SCRIPTABLE NS_IMETHOD SetBufferSegmentSize(PRUint32 aBufferSegmentSize) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetBufferSegmentSize(aBufferSegmentSize); } \
  NS_SCRIPTABLE NS_IMETHOD GetBufferMaxSize(PRUint32 *aBufferMaxSize) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBufferMaxSize(aBufferMaxSize); } \
  NS_SCRIPTABLE NS_IMETHOD SetBufferMaxSize(PRUint32 aBufferMaxSize) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetBufferMaxSize(aBufferMaxSize); } \
  NS_SCRIPTABLE NS_IMETHOD GetHeadersMaxSize(PRUint32 *aHeadersMaxSize) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetHeadersMaxSize(aHeadersMaxSize); } \
  NS_SCRIPTABLE NS_IMETHOD SetHeadersMaxSize(PRUint32 aHeadersMaxSize) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetHeadersMaxSize(aHeadersMaxSize); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPipeTransport : public nsIPipeTransport
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPIPETRANSPORT

  nsPipeTransport();

private:
  ~nsPipeTransport();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPipeTransport, nsIPipeTransport)

nsPipeTransport::nsPipeTransport()
{
  /* member initializers and constructor code */
}

nsPipeTransport::~nsPipeTransport()
{
  /* destructor code */
}

/* void initWithWorkDir (in nsIFile executable, in nsIFile cwd, in unsigned long startupFlags); */
NS_IMETHODIMP nsPipeTransport::InitWithWorkDir(nsIFile *executable, nsIFile *cwd, PRUint32 startupFlags)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void openPipe ([array, size_is (argCount)] in wstring args, in unsigned long argCount, [array, size_is (envCount)] in wstring env, in unsigned long envCount, in unsigned long timeoutMS, in string killString, in boolean mergeStderr, in nsIPipeListener stderrConsole); */
NS_IMETHODIMP nsPipeTransport::OpenPipe(const PRUnichar **args, PRUint32 argCount, const PRUnichar **env, PRUint32 envCount, PRUint32 timeoutMS, const char *killString, PRBool mergeStderr, nsIPipeListener *stderrConsole)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIPipeListener stderrConsole; */
NS_IMETHODIMP nsPipeTransport::GetStderrConsole(nsIPipeListener **aStderrConsole)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIStreamListener listener; */
NS_IMETHODIMP nsPipeTransport::GetListener(nsIStreamListener **aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIPipeTransportHeaders headerProcessor; */
NS_IMETHODIMP nsPipeTransport::GetHeaderProcessor(nsIPipeTransportHeaders **aHeaderProcessor)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsPipeTransport::SetHeaderProcessor(nsIPipeTransportHeaders *aHeaderProcessor)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute boolean loggingEnabled; */
NS_IMETHODIMP nsPipeTransport::GetLoggingEnabled(PRBool *aLoggingEnabled)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsPipeTransport::SetLoggingEnabled(PRBool aLoggingEnabled)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIInputStream openInputStream (in unsigned long offset, in unsigned long count, in unsigned long flags); */
NS_IMETHODIMP nsPipeTransport::OpenInputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIInputStream **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIOutputStream openOutputStream (in unsigned long offset, in unsigned long count, in unsigned long flags); */
NS_IMETHODIMP nsPipeTransport::OpenOutputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIOutputStream **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIRequest asyncRead (in nsIStreamListener listener, in nsISupports ctxt, in unsigned long offset, in unsigned long count, in unsigned long flags); */
NS_IMETHODIMP nsPipeTransport::AsyncRead(nsIStreamListener *listener, nsISupports *ctxt, PRUint32 offset, PRUint32 count, PRUint32 flags, nsIRequest **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void join (); */
NS_IMETHODIMP nsPipeTransport::Join()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void terminate (); */
NS_IMETHODIMP nsPipeTransport::Terminate()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void writeSync (in string inputData, in unsigned long inputLength); */
NS_IMETHODIMP nsPipeTransport::WriteSync(const char *inputData, PRUint32 inputLength)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void closeStdin (); */
NS_IMETHODIMP nsPipeTransport::CloseStdin()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void writeAsync (in nsIInputStream aFromStream, in unsigned long aCount, in boolean closeAfterWrite); */
NS_IMETHODIMP nsPipeTransport::WriteAsync(nsIInputStream *aFromStream, PRUint32 aCount, PRBool closeAfterWrite)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* string readLine (in long maxOutputLen); */
NS_IMETHODIMP nsPipeTransport::ReadLine(PRInt32 maxOutputLen, char **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute unsigned long bufferSegmentSize; */
NS_IMETHODIMP nsPipeTransport::GetBufferSegmentSize(PRUint32 *aBufferSegmentSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsPipeTransport::SetBufferSegmentSize(PRUint32 aBufferSegmentSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute unsigned long bufferMaxSize; */
NS_IMETHODIMP nsPipeTransport::GetBufferMaxSize(PRUint32 *aBufferMaxSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsPipeTransport::SetBufferMaxSize(PRUint32 aBufferMaxSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute unsigned long headersMaxSize; */
NS_IMETHODIMP nsPipeTransport::GetHeadersMaxSize(PRUint32 *aHeadersMaxSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsPipeTransport::SetHeadersMaxSize(PRUint32 aHeadersMaxSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIPipeTransportHeaders */
#define NS_IPIPETRANSPORTHEADERS_IID_STR "8431e110-7ab1-11d4-8f02-006008948af5"

#define NS_IPIPETRANSPORTHEADERS_IID \
  {0x8431e110, 0x7ab1, 0x11d4, \
    { 0x8f, 0x02, 0x00, 0x60, 0x08, 0x94, 0x8a, 0xf5 }}

class NS_NO_VTABLE NS_SCRIPTABLE nsIPipeTransportHeaders : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IPIPETRANSPORTHEADERS_IID)

  /**
  * nsIPipeTransportHeaders is a helper interface to parse MIME headers as
  * specified by RFC 822.
  */
/**
   * Calls channel to parse MIME headers, returning content length
   * or -1 for unknown content length.
   * If invalid MIME headers or no channel set, returns error.
   */
  /* long parseMimeHeaders (in string mimeHeaders, in unsigned long count); */
  NS_SCRIPTABLE NS_IMETHOD ParseMimeHeaders(const char *mimeHeaders, PRUint32 count, PRInt32 *_retval NS_OUTPARAM) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIPipeTransportHeaders, NS_IPIPETRANSPORTHEADERS_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPIPETRANSPORTHEADERS \
  NS_SCRIPTABLE NS_IMETHOD ParseMimeHeaders(const char *mimeHeaders, PRUint32 count, PRInt32 *_retval NS_OUTPARAM); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPIPETRANSPORTHEADERS(_to) \
  NS_SCRIPTABLE NS_IMETHOD ParseMimeHeaders(const char *mimeHeaders, PRUint32 count, PRInt32 *_retval NS_OUTPARAM) { return _to ParseMimeHeaders(mimeHeaders, count, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPIPETRANSPORTHEADERS(_to) \
  NS_SCRIPTABLE NS_IMETHOD ParseMimeHeaders(const char *mimeHeaders, PRUint32 count, PRInt32 *_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->ParseMimeHeaders(mimeHeaders, count, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPipeTransportHeaders : public nsIPipeTransportHeaders
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPIPETRANSPORTHEADERS

  nsPipeTransportHeaders();

private:
  ~nsPipeTransportHeaders();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPipeTransportHeaders, nsIPipeTransportHeaders)

nsPipeTransportHeaders::nsPipeTransportHeaders()
{
  /* member initializers and constructor code */
}

nsPipeTransportHeaders::~nsPipeTransportHeaders()
{
  /* destructor code */
}

/* long parseMimeHeaders (in string mimeHeaders, in unsigned long count); */
NS_IMETHODIMP nsPipeTransportHeaders::ParseMimeHeaders(const char *mimeHeaders, PRUint32 count, PRInt32 *_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIPipeTransportListener */
#define NS_IPIPETRANSPORTLISTENER_IID_STR "8431e120-7ab1-11d4-8f02-006008948af5"

#define NS_IPIPETRANSPORTLISTENER_IID \
  {0x8431e120, 0x7ab1, 0x11d4, \
    { 0x8f, 0x02, 0x00, 0x60, 0x08, 0x94, 0x8a, 0xf5 }}

class NS_NO_VTABLE NS_SCRIPTABLE nsIPipeTransportListener : public nsIPipeTransportHeaders {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IPIPETRANSPORTLISTENER_IID)

  /**
  * nsIPipeTransportListener is a helper interface for nsIPipeTransport.
  * It is used to start and stop the listener stream of nsIPipeTransport.
  */
/**
   * Starts listener, and invokes OnStartRequest on listener, if any.
   * NOTE: Should not be called if blocked for synchronous read.
   */
  /* void startRequest (); */
  NS_SCRIPTABLE NS_IMETHOD StartRequest(void) = 0;

  /**
   * Stops listener
   */
  /* void stopRequest (in nsresult status); */
  NS_SCRIPTABLE NS_IMETHOD StopRequest(nsresult status) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIPipeTransportListener, NS_IPIPETRANSPORTLISTENER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPIPETRANSPORTLISTENER \
  NS_SCRIPTABLE NS_IMETHOD StartRequest(void); \
  NS_SCRIPTABLE NS_IMETHOD StopRequest(nsresult status); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPIPETRANSPORTLISTENER(_to) \
  NS_SCRIPTABLE NS_IMETHOD StartRequest(void) { return _to StartRequest(); } \
  NS_SCRIPTABLE NS_IMETHOD StopRequest(nsresult status) { return _to StopRequest(status); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPIPETRANSPORTLISTENER(_to) \
  NS_SCRIPTABLE NS_IMETHOD StartRequest(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->StartRequest(); } \
  NS_SCRIPTABLE NS_IMETHOD StopRequest(nsresult status) { return !_to ? NS_ERROR_NULL_POINTER : _to->StopRequest(status); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPipeTransportListener : public nsIPipeTransportListener
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPIPETRANSPORTLISTENER

  nsPipeTransportListener();

private:
  ~nsPipeTransportListener();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPipeTransportListener, nsIPipeTransportListener)

nsPipeTransportListener::nsPipeTransportListener()
{
  /* member initializers and constructor code */
}

nsPipeTransportListener::~nsPipeTransportListener()
{
  /* destructor code */
}

/* void startRequest (); */
NS_IMETHODIMP nsPipeTransportListener::StartRequest()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void stopRequest (in nsresult status); */
NS_IMETHODIMP nsPipeTransportListener::StopRequest(nsresult status)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIPipeTransport_h__ */
